////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                            INCLUDES                                                        //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <math.h>
#include <windows.h>										// Header File For Windows
#include <stdio.h>											// Header File For Standard Input / Output
#include <stdarg.h>											// Header File For Variable Argument Routines
#include <gl\gl.h>											// Header File For The OpenGL32 Library
#include <gl\glu.h>											// Header File For The GLu32 Library
#include <gl\glaux.h>										// Header File For The Glaux Library

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                GLOBAL VARIABLES AND DATA STRUCTURES                                        //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HDC			hDC=NULL;										// Private GDI Device Context
HGLRC		hRC=NULL;										// Permanent Rendering Context
HWND		hWnd=NULL;										// Holds Our Window Handle
HINSTANCE	hInstance;										// Holds The Instance Of The Application

POINT mpos;                                                 // Used to store mouse position

#define	MAX_PARTICLES	2500	                        	// Number Of Particles To Create 

bool	keys[256];											// Array Used For The Keyboard Routine
bool	WallCleared;										// Are all bricks cleared?
bool	GameOver;											// Is The Game Over?
bool	active=TRUE;										// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;									// Fullscreen Flag Set To Fullscreen Mode By Default
bool    BrickHit=false;                                     // Has a brick been hit?
bool    Menu=false;                                         // Is the menu up?
bool    Particles=true;                                     // Are particles on?
bool    DisplayFPS=false;                                   // Display FPS?
bool    DisplaySpeed=true;
bool    WallHit=false;
bool    PWave=false;
bool    GameOn=false;
bool    FirstPass=false;
bool    Instructions=false;
bool    CheatEngaged=false;
bool    BatHit=false;

int     MultiBall;                                          // Used for superball power up
int     SlowBall;                                           // Used for slowball power up
int     FastBall;                                           // Used for fastball power up
int     Gun;                                                // Not used atm
int     AddBrick;                                           // Use for add brick power up
int     MinusBrick;                                         // Used for minus brick power up
int     IntroCount=0;
int     index=14;
int		adjust=3;											// Speed Adjustment For Really Slow Video Cards
int		lives=5;											// Player Lives
int		level=1;											// Game Level
int     loop1;                                              // loop variable
int     loop2;                                              // loop variable
int     TimerCount=0;                                       // Used by game timer
int     Score=0;                                            // Player score
int     NoOfBricksHit=0;                                    // Number of bricks hit (reset when ball hits bat)
int     Section;                                            // Which section of bat collides with ball
int     Count;
int     Count2=1;
int     Brick;                                              // Which brick has been hit
int     NumberOfLevels=15;
int     Rad;
int     Rad2;

int     test=0;                                             // Debugging variable
int     test2=0;                                            // Debugging variable
int     test3=0;                                            // Debugging variable
int     test4=0;                                            // Debugging variable
int     test5=0;

int     Option=1;                                           // Used in displaying the menu

const   NumberOfTextures=32;                                // Is actaully the number of textures

float   Zoom=-50.0;
float   Zoom2;
float   Time1;                                              // Used by game timer
float   Time2;                                              // Used by game timer

float   Time3;
float   Time4;
float   Time5;
float   FPS;
float   param1;
float   param2;

char    Time;
long    TimeL1;
int     TimeI1;
long    TimeL2;
int     TimeI2;

int     Frame=0;

float   DiffTime;                                           // Used by game timer    
float   OverallSpeed;                                       // Used by game timer and used when displacing objects
float   ratio;                                              // Used in bat collision
float   grad1;                                              // Used in bat collision
float   grad2;                                              // Used in bat collision        
float   ratio1;                                             // Used in bat collision
float   ratio2;                                             // Used in bat collision        
float   batlx;                                              // Used in bat collision
float   batly;                                              // Used in bat collision
float	slowdown=4.0f;
float   WaveSpeed=1.0f;
float   Zoom3;    
                                     
float   Strip;
float   Pvelocity=1.0f;
int     Pdensity=200;

struct	brick												// Structure for wall bricks
{
	GLfloat		TopLeftX,TopRightX,BottomLeftX,BottomRightX;// Front face co ordinates of brick
    GLfloat		TopLeftY,TopRightY,BottomLeftY,BottomRightY;
    bool        BrickCleared;                               // Has brick been cleared?
	GLfloat     Depth;                                      // How deep is brick?
    GLfloat     Thickness;                                  // How thick is brick?
    int         colour;                                     // What colour is brick?    
    int         special;                                    // Is it a special brick?
    GLfloat     dx;
    GLfloat     dy;
    GLfloat     dz;
    bool        Moving;                                    
};

struct  brick Wall[41];										// Array of bricks

struct  object                                              // Data structure for bat and ball        
{
    GLfloat x,y,z;                                          // Position components
    GLfloat dx,dy,dz;                                       // Velocity components
};

struct  object  bat;                                        // Bat data
struct  object  ball;                                       // Ball data
struct  object  Wave[3];                                    // wave from ball

struct			 											// Create A Structure For The Timer Information
{
  __int64       frequency;									// Timer Frequency
  float         resolution;									// Timer Resolution
  unsigned long mm_timer_start;								// Multimedia Timer Start Value
  unsigned long mm_timer_elapsed;							// Multimedia Timer Elapsed Time
  bool			performance_timer;							// Using The Performance Timer?
  __int64       performance_timer_start;					// Performance Timer Start Value
  __int64       performance_timer_elapsed;					// Performance Timer Elapsed Time
} timer;													// Structure Is Named timer

typedef struct			                        			// Create A Structure For Particle
{
	bool	active;			                        		// Active (Yes/No)

    int     texture;	                                    // What texture?
    int     size;

    float	life;			                        		// Particle Life
	float	x;			                            		// X Position
	float	y;			                            		// Y Position
	float	z;			                            		// Z Position
	float	dx;			                            		// X Direction
	float	dy;			                            		// Y Direction
	float	dz;			                               		// Z Direction
	float	xg;			                            		// X Gravity
	float	yg;				                            	// Y Gravity
	float	zg;

    				                            	// Z Gravity
}
particles;					                            	// Particles Structure

particles particle[MAX_PARTICLES];		                	// Particle Array (Room For Particle Info)  

static GLfloat colors[12][3]=				// Rainbow Of Colors
{
	{1.0f,0.5f,0.5f},{1.0f,0.75f,0.5f},{1.0f,1.0f,0.5f},{0.75f,1.0f,0.5f},
	{0.5f,1.0f,0.5f},{0.5f,1.0f,0.75f},{0.5f,1.0f,1.0f},{0.5f,0.75f,1.0f},
	{0.5f,0.5f,1.0f},{0.75f,0.5f,1.0f},{1.0f,0.5f,1.0f},{1.0f,0.5f,0.75f}
};

float   steps[6]={ 1.0f, 0.9f, 0.99f, 1.0f, 1.01f, 1.1f };					// Stepping Values For Slow Video Adjustment

GLuint	texture[12];										// Font Texture Storage Space
GLuint	base;												// Base Display List For The Font
GLuint	col;                                                // 

GLfloat LightAmbient[]=		{ 0.75f, 0.75f, 0.75f, 1.0f };  //Lighting set up
GLfloat LightDiffuse[]=		{ 1.0f, 1.0f, 1.0f, 1.0f };     //Lighting set up    
GLfloat LightPosition[]=	{ -5.0f, -1.0f, -5.5f, 1.0f };    //Lighting set up  

GLfloat BallThickness=0.05f;                                // Ball thickness
GLfloat BatWidth=0.7f;                                      // Bat width
GLfloat BatHeight=0.5f;                                     // Bat height
GLfloat DistFromBatToBall;                                  // Not used
GLfloat SquareOfBat;                                        // Not used

GLUquadricObj *quadratic;                                   // Not used

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION DECLARATIONS                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);		// Declaration For WndProc

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION DEFINITIONS                                                 //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                         FUNCTION : ABS()                                                   //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GLfloat ABS(GLfloat A)
{
    if (A<0)
    A=-A;
    return A;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : FLOAT TO CHAR                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int FloatToInt(float A)
{
    long    longint=(long)A;
    int     sint=(int)longint;

    return  sint;
}    


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : INITIALISE TIMER                                              //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void TimerInit(void)										// Initialize Our Timer (Get It Ready)
{
	memset(&timer, 0, sizeof(timer));						// Clear Our Timer Structure

	// Check To See If A Performance Counter Is Available
	// If One Is Available The Timer Frequency Will Be Updated
	if (!QueryPerformanceFrequency((LARGE_INTEGER *) &timer.frequency))
	{
		// No Performace Counter Available
		timer.performance_timer	= FALSE;					// Set Performance Timer To FALSE
		timer.mm_timer_start	= timeGetTime();			// Use timeGetTime() To Get Current Time
		timer.resolution		= 1.0f/1000.0f;				// Set Our Timer Resolution To .001f
		timer.frequency			= 1000;						// Set Our Timer Frequency To 1000
		timer.mm_timer_elapsed	= timer.mm_timer_start;		// Set The Elapsed Time To The Current Time
	}
	else
	{
		// Performance Counter Is Available, Use It Instead Of The Multimedia Timer
		// Get The Current Time And Store It In performance_timer_start
		QueryPerformanceCounter((LARGE_INTEGER *) &timer.performance_timer_start);
		timer.performance_timer			= TRUE;				// Set Performance Timer To TRUE
		// Calculate The Timer Resolution Using The Timer Frequency
		timer.resolution				= (float) (((double)1.0f)/((double)timer.frequency));
		// Set The Elapsed Time To The Current Time
		timer.performance_timer_elapsed	= timer.performance_timer_start;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                        FUNCTION : GET TIME                                                 //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

float TimerGetTime()										// Get Time In Milliseconds
{
	__int64 time;											// time Will Hold A 64 Bit Integer

	if (timer.performance_timer)							// Are We Using The Performance Timer?
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &time);	// Grab The Current Performance Time
		// Return The Current Time Minus The Start Time Multiplied By The Resolution And 1000 (To Get MS)
		return ( (float) ( time - timer.performance_timer_start) * timer.resolution)*1000.0f;
	}
	else
	{
		// Return The Current Time Minus The Start Time Multiplied By The Resolution And 1000 (To Get MS)
		return( (float) ( timeGetTime() - timer.mm_timer_start) * timer.resolution)*1000.0f;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                      FUNCTION : RESET OBJECTS                                              //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ResetObjects(void)										// Reset bat and ball
{
	bat.x=0.0f;												// 
	bat.y=0.0f;												// Reset bat position
    bat.z=0.0f;                                             //

    ball.x=0.0f;											// 
	ball.y=0.0f;											// Reset ball position
    ball.z=-2.0f;                                           //

    ball.dx=-0.1f;                                          //
    ball.dy=0.1f;                                           // Reset ball speed
    ball.dz=-1.5f;                                         //
//  ball.dz=-0.1f;

    
    bat.dx=0.0;                                             //
    bat.dy=0.0;                                             // Reset bat position
    bat.dz=0.0;                                             // 

    SetCursorPos(320,240);                                  // Set mouse to centre of screen

    //Reset any power ups
    SlowBall=0;                                             
    FastBall=0;
    MultiBall=0;
    Gun=0;
    AddBrick=0;
    MinusBrick=0;
    NoOfBricksHit=0;
       
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                     FUNCTION : DISPLACE OBJECTS                                            //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void DisplaceObjects(void)
{
    //bat
    bat.x+=bat.dx/25*OverallSpeed;
    bat.y+=bat.dy/25*OverallSpeed;

    //ball
    ball.x+=ball.dx/25*OverallSpeed;
    ball.y+=ball.dy/25*OverallSpeed;
    ball.z+=ball.dz/25*OverallSpeed;

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                      FUNCTION : DECELERATE BAT                                             //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void DecelerateBat(void)
{
    // Not used in mouse control version
    bat.dx*=.96f;
    bat.dy*=.93f;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : LIMIT BAT MOVEMENT                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void LimitBatMovement(void)
{
    //Keep bat on screen
    if (bat.y/*+BatHeight*/>=2.0f)
    {
        bat.y=2.0f/*-BatHeight*/;
    }

    if (bat.y/*-BatHeight*/<=-2.0f)
    {
        bat.y=/*BatHeight-*/-2.0f;
    }

    if (bat.x/*+BatWidth*/>=2.7f)
    {
        bat.x=2.7f/*-BatWidth*/;
    }

    if (bat.x/*-BatWidth*/<=-2.7f)      
    {
        bat.x=/*BatWidth-*/-2.7f;
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                FUNCTION : CHECK FOR CONTAINER COLLISION                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckForContainerCollision(void)

{
    //Check for collisions with walls

    //Right wall
    if ((ball.x+BallThickness<=2.7)&&(ball.x+BallThickness>=2.65)&&(ball.dx>0))
    {
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        ball.dx=-ball.dx;
        Score++;
        WallHit=true;
    }

    //Left wall
    if ((ball.x-BallThickness>=-2.7)&&(ball.x-BallThickness<=-2.65)&&(ball.dx<0))
    {
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        ball.dx=-ball.dx;
        Score++;
        WallHit=true;
    }
    
    //Ceiling
    if ((ball.y+BallThickness<=2.0)&&(ball.y+BallThickness>=1.95)&&(ball.dy>0))
    {
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        ball.dy=-ball.dy;
        Score++;
        WallHit=true;
    }

    //Floor
    if ((ball.y-BallThickness>=-2.0)&&(ball.y-BallThickness<=-1.95)&&(ball.dy<0))
    {
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        ball.dy=-ball.dy;
        Score++;
        WallHit=true;
    }

    //Back wall
    if ((ball.z-BallThickness>=-10.0)&&(ball.z-BallThickness<=-9.95)&&(ball.dz<0))
    {
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        ball.dz=-ball.dz;
        Score++;
        WallHit=true;
    }

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                FUNCTION : CHECK FOR BAT COLLISION                                          //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckForBatCollision(void)

{

    if ((ball.z+BallThickness<=3.0)&&(ball.z+BallThickness>=-0.05)&&(ball.dz>0)&&
        (ball.x<=bat.x+BatWidth)&&(ball.x>=bat.x-BatWidth)&&
        (ball.y<=bat.y+BatHeight)&&(ball.y>=bat.y-BatHeight)
       )
    {   
        ball.z-=ball.dz/25*OverallSpeed;                        
        PlaySound("Data/Tennis1.wav", NULL, SND_ASYNC);
        ball.dz=-ball.dz*1.020f*steps[adjust];    
        //DistFromBatToBall=hypot(ball.x-bat.x,ball.y-bat.x);
        //SquareOfBat=hypot(BatWidth,BatHeight);        
        ratio=1.075f;//*DistFromBatToBall/SquareOfBat;
        NoOfBricksHit=0;
        Score+=2;

        batly=ball.y-bat.y;
        batlx=ball.x-bat.x;
        
        grad1=2.0f*(BatHeight/BatWidth);
        grad2=BatHeight/(2*BatWidth);        
        ratio1=1.075f;
        ratio2=1.15f;

        Section=0;
        
        BatHit=true;

        //section 9?
        
        if ((batlx>=-0.2f)&&(batlx<=0.2f)&&(batly>=-0.15f)&&(batly<=0.15f))    
        {
            ball.dz=float(-hypot(hypot(ball.dy,ball.dx),ball.dz));
            ball.dy=0.0f;
            ball.dx=0.0f;
            Section=9;
        }
        //else
        
            
        //Section 1
        if ((batlx>=-0.2)&&(batlx<=0.2)&&(batly>=0.15)&&(batly<=0.5))
        {
            ball.dx=0;
            ball.dy=ABS(ball.dy)*ratio2;
            if (ball.dy==0.0f) {ball.dy=0.1f;}
            Section=1;
        }

        //Section 2
        
        if ((batlx>=0.2)&&(batlx<=0.7)&&(batly>=0.15)&&(batly<=0.5))
        {
            ball.dx=ABS(ball.dx)*ratio1;
            ball.dy=ABS(ball.dy)*ratio1;
            if (ball.dx==0.0f) {ball.dx=0.1f;}
            if (ball.dy==0.0f) {ball.dy=0.1f;}
            Section=2;
        }

        //Section 3
       
        if ((batlx>=0.2)&&(batlx<=0.7)&&(batly>=-0.15)&&(batly<=0.15))
        {
            ball.dx=ABS(ball.dx)*ratio2;
            ball.dy=0.0f;
            if (ball.dx==0.0f) {ball.dx=0.1f;}
            Section=3;
        }

        //Section 4
        
        if ((batlx>=0.2)&&(batlx<=0.7)&&(batly>=-0.5)&&(batly<=-0.15))
        {
            ball.dx=ABS(ball.dx)*ratio1;
            ball.dy=-ABS(ball.dy)*ratio1;
            if (ball.dx==0.0f) {ball.dx=0.1f;}
            if (ball.dy==0.0f) {ball.dy=-0.1f;}            
            Section=4;
        }

        //Section 5
        
        if ((batlx>=-0.2f)&&(batlx<=0.2f)&&(batly>=-0.5f)&&(batly<=-0.15f))
        {
            ball.dx=0;
            ball.dy=-ABS(ball.dy)*ratio2;
            if (ball.dy==0.0f) {ball.dy=-0.1f;}
            Section=5;
        }

        //Section 6
        
        if ((batlx>=-0.7f)&&(batlx<=-0.2f)&&(batly>=-0.5f)&&(batly<=-0.15f))
        {
            ball.dx=-ABS(ball.dx)*ratio1;
            ball.dy=-ABS(ball.dy)*ratio1;
            if (ball.dx==0.0f) {ball.dx=-0.1f;}
            if (ball.dy==0.0f) {ball.dy=-0.1f;}
            Section=6;
        }

        //Section 7
      
        if ((batlx>=-0.7f)&&(batlx<=-0.2f)&&(batly>=-0.15f)&&(batly<=0.15f))
        {
            ball.dx=-ABS(ball.dx)*ratio2;
            ball.dy=0.0f;
            if (ball.dx==0.0f) {ball.dx=-0.1f;}
            Section=7;
        }

        //Section 8
        
        if ((batlx>=-0.7f)&&(batlx<=-0.2f)&&(batly>=0.15f)&&(batly<=0.5f))
        {
            ball.dx=-ABS(ball.dx)*ratio1;
            ball.dy=ABS(ball.dy)*ratio1;
            if (ball.dx==0.0f) {ball.dx=-0.1f;}
            if (ball.dy==0.0f) {ball.dy=0.1f;}
            Section=8;
        }
        
        
   
     }
}

/*

copy

void CheckForBatCollision(void)

{

    if ((ball.z+BallThickness<=3.0)&&(ball.z+BallThickness>=-0.05)&&(ball.dz>0)&&
        (ball.x<=bat.x+BatWidth)&&(ball.x>=bat.x-BatWidth)&&
        (ball.y<=bat.y+BatHeight)&&(ball.y>=bat.y-BatHeight)
       )
    {   
        ball.z-=ball.dz/25*OverallSpeed;
        PlaySound("Data/Tennis1.wav", NULL, SND_ASYNC);
        ball.dz=-ball.dz*1.05;    
        //DistFromBatToBall=hypot(ball.x-bat.x,ball.y-bat.x);
        //SquareOfBat=hypot(BatWidth,BatHeight);        
        ratio=1.075;//*DistFromBatToBall/SquareOfBat;
        NoOfBricksHit=0;
        Score+=1;

        //Top left of bat
        if ((ball.x<bat.x)&&(ball.y>bat.y))
        {
            if (ball.dy<0)
                {ball.dy=-ball.dy*ratio;}
            if (ball.dx>0)
                {ball.dx=-ball.dx*ratio;}
        }
        
        //Top right of bat
        if ((ball.x>bat.x)&&(ball.y>bat.y))
        {
            if (ball.dy<0)
                {ball.dy=-ball.dy*ratio;}
            if (ball.dx<0)
                {ball.dx=-ball.dx*ratio;}
        }

        //Bottom right of bat
        if ((ball.x>bat.x)&&(ball.y<bat.y))
        {
            if (ball.dy>0)
                {ball.dy=-ball.dy*ratio;}
            if (ball.dx<0)
                {ball.dx=-ball.dx*ratio;}
        }

        //Bottom left of bat
        if ((ball.x<bat.x)&&(ball.y<bat.y))
        {
            if (ball.dy>0)
                {ball.dy=-ball.dy*ratio;}
            if (ball.dx>0)
                {ball.dx=-ball.dx*ratio;}
        }

    }
}*/

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : LIMIT BALL MOVEMENT                                          //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void LimitBallMovement(void)

{
    // Make sure ball is always in world
    if (ball.y>=2.0f)
    {
        ball.y=2.0f;
        ball.dy=-ball.dy;
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        Score++;
        WallHit=true;
    }

    if (ball.y<=-2.0f)
    {
        ball.y=-2.0f;
        ball.dy=-ball.dy;
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        Score++;
        WallHit=true;
    }

    if (ball.x>=2.7f)
    {
        ball.x=2.7f;
        ball.dx=-ball.dx;
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        Score++;
        WallHit=true;
    }

    if (ball.x<=-2.7f)      
    {
        ball.x=-2.7f;
        ball.dx=-ball.dx;
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        Score++;
        WallHit=true;
    }

    if (ball.z<=-10.0f)      
    {
        ball.z=-10.0f;
        ball.dz=-ball.dz;
        PlaySound("Data/Tennis.wav", NULL, SND_ASYNC);
        Score++;
        WallHit=true;
    }


}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : PROXIMITY WARNING                                            //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ProximityWarning(void)
{
    if ((ball.z>-3.0)&&(ball.z<-2.0)) //Nb 0.0 is the screen and -10.0 the back wall
    {
        PWave=true;
        
        for(loop1=0;loop1<3;loop1++)
        {
            Wave[loop1].x=ball.x+WaveSpeed*OverallSpeed/50;
            Wave[loop1].y=ball.y+WaveSpeed*OverallSpeed/50;
            Wave[loop1].z=ball.z;                    
        }
    }
}    

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : POPULATE BRICK ARRAY                                         //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void PopulateBrickArray(void)
{
    //Populate brick array and generate a few random bricks    

    //Row 1    


    //Top line of bricks (1-4)
    for (loop1=1;loop1<=4;loop1++)
    {
        Wall[loop1].TopLeftX=-2.7f+(loop1-1)*1.35f;          Wall[loop1].TopLeftY=2.0f;
        Wall[loop1].TopRightX=-1.35f+(loop1-1)*1.35f;        Wall[loop1].TopRightY=2.0f;
        Wall[loop1].BottomLeftX=-2.7f+(loop1-1)*1.35f;       Wall[loop1].BottomLeftY=2.0f/3.0f;
        Wall[loop1].BottomRightX=-1.35f+(loop1-1)*1.35f;     Wall[loop1].BottomRightY=2.0f/3.0f;
    }
    //Middle line of bricks
    //Brick 5
        Wall[5].TopLeftX=-2.7f;                         Wall[5].TopLeftY=2.0f/3.0f;
        Wall[5].TopRightX=-2.025f;                      Wall[5].TopRightY=2.0f/3.0f;
        Wall[5].BottomLeftX=-2.7f;                      Wall[5].BottomLeftY=-2.0f/3.0f;
        Wall[5].BottomRightX=-2.025f;                   Wall[5].BottomRightY=-2.0f/3.0f;
    //Bricks (6-8)
    for (loop1=6;loop1<=8;loop1++)
    {
        Wall[loop1].TopLeftX=-2.025f+(loop1-6)*1.35f;        Wall[loop1].TopLeftY=2.0f/3.0f;
        Wall[loop1].TopRightX=-0.675f+(loop1-6)*1.35f;       Wall[loop1].TopRightY=2.0f/3.0f;
        Wall[loop1].BottomLeftX=-2.025f+(loop1-6)*1.35f;     Wall[loop1].BottomLeftY=-2.0f/3.0f;
        Wall[loop1].BottomRightX=-0.675f+(loop1-6)*1.35f;    Wall[loop1].BottomRightY=-2.0f/3.0f;
    }
    //Brick 9
        Wall[9].TopLeftX=2.025f;                        Wall[9].TopLeftY=2.0f/3.0f;
        Wall[9].TopRightX=2.7f;                         Wall[9].TopRightY=2.0f/3.0f;
        Wall[9].BottomLeftX=2.025f;                     Wall[9].BottomLeftY=-2.0f/3.0f;
        Wall[9].BottomRightX=2.7f;                      Wall[9].BottomRightY=-2.0f/3.0f;
    //Bottom line of bricks (10-13)
    for (loop1=10;loop1<=13;loop1++)
    {
        Wall[loop1].TopLeftX=-2.7f+(loop1-10)*1.35f;          Wall[loop1].TopLeftY=-2.0f/3.0f;
        Wall[loop1].TopRightX=-1.35f+(loop1-10)*1.35f;        Wall[loop1].TopRightY=-2.0f/3.0f;
        Wall[loop1].BottomLeftX=-2.7f+(loop1-10)*1.35f;       Wall[loop1].BottomLeftY=-2.0f;
        Wall[loop1].BottomRightX=-1.35f+(loop1-10)*1.35f;     Wall[loop1].BottomRightY=-2.0f;
    }
    //Give Brick's Z position + thickness and set cleared to false
    for (loop1=1;loop1<=13;loop1++)
    {
        Wall[loop1].Depth=-9.5f;
        Wall[loop1].Thickness=0.5f;
        Wall[loop1].BrickCleared=FALSE;
    }


    //Row 2


    //Top line of bricks
    //Brick 14
        Wall[14].TopLeftX=-2.7f;                         Wall[14].TopLeftY=2.0f;
        Wall[14].TopRightX=-2.025f;                      Wall[14].TopRightY=2.0f;
        Wall[14].BottomLeftX=-2.7f;                      Wall[14].BottomLeftY=2.0f/3.0f;
        Wall[14].BottomRightX=-2.025f;                   Wall[14].BottomRightY=2.0f/3.0f;
    //Bricks (15-17)
    for (loop1=15;loop1<=17;loop1++)
    {
        Wall[loop1].TopLeftX=-2.025f+(loop1-15)*1.35f;        Wall[loop1].TopLeftY=2.0f;
        Wall[loop1].TopRightX=-0.675f+(loop1-15)*1.35f;       Wall[loop1].TopRightY=2.0f;
        Wall[loop1].BottomLeftX=-2.025f+(loop1-15)*1.35f;     Wall[loop1].BottomLeftY=2.0f/3.0f;
        Wall[loop1].BottomRightX=-0.675f+(loop1-15)*1.35f;    Wall[loop1].BottomRightY=2.0f/3.0f;
    }
    //Brick 18
        Wall[18].TopLeftX=2.025f;                        Wall[18].TopLeftY=2.0f;
        Wall[18].TopRightX=2.7f;                         Wall[18].TopRightY=2.0f;
        Wall[18].BottomLeftX=2.025f;                     Wall[18].BottomLeftY=2.0f/3.0f;
        Wall[18].BottomRightX=2.7f;                      Wall[18].BottomRightY=2.0f/3.0f;
    //Middle line of bricks (19-22)
    for (loop1=19;loop1<=22;loop1++)
    {
        Wall[loop1].TopLeftX=-2.7f+(loop1-19)*1.35f;          Wall[loop1].TopLeftY=2.0f/3.0f;
        Wall[loop1].TopRightX=-1.35f+(loop1-19)*1.35f;        Wall[loop1].TopRightY=2.0f/3.0f;
        Wall[loop1].BottomLeftX=-2.7f+(loop1-19)*1.35f;       Wall[loop1].BottomLeftY=-2.0f/3.0f;
        Wall[loop1].BottomRightX=-1.35f+(loop1-19)*1.35f;     Wall[loop1].BottomRightY=-2.0f/3.0f;       
    }    
    //Bottom line of bricks   
    //Brick 23
        Wall[23].TopLeftX=-2.7f;                         Wall[23].TopLeftY=-2.0f/3.0f;
        Wall[23].TopRightX=-2.025f;                      Wall[23].TopRightY=-2.0f/3.0f;
        Wall[23].BottomLeftX=-2.7f;                      Wall[23].BottomLeftY=-2.0f;
        Wall[23].BottomRightX=-2.025f;                   Wall[23].BottomRightY=-2.0f;
    //Bricks (24-26)
    for (loop1=24;loop1<=26;loop1++)
    {
        Wall[loop1].TopLeftX=-2.025f+(loop1-24)*1.35f;        Wall[loop1].TopLeftY=-2.0f/3.0f;
        Wall[loop1].TopRightX=-0.675f+(loop1-24)*1.35f;       Wall[loop1].TopRightY=-2.0f/3.0f;
        Wall[loop1].BottomLeftX=-2.025f+(loop1-24)*1.35f;     Wall[loop1].BottomLeftY=-2.0f;
        Wall[loop1].BottomRightX=-0.675f+(loop1-24)*1.35f;    Wall[loop1].BottomRightY=-2.0f;
    }
    //Brick 27
        Wall[27].TopLeftX=2.025f;                        Wall[27].TopLeftY=-2.0f/3.0f;
        Wall[27].TopRightX=2.7f;                         Wall[27].TopRightY=-2.0f/3.0f;
        Wall[27].BottomLeftX=2.025f;                     Wall[27].BottomLeftY=-2.0f;
        Wall[27].BottomRightX=2.7f;                      Wall[27].BottomRightY=-2.0f;
    //Give Brick's Z position + thickness and set cleared to false
    for (loop1=14;loop1<=27;loop1++)
    {
        Wall[loop1].Depth=-8.0f;
        Wall[loop1].Thickness=0.5f;
        Wall[loop1].BrickCleared=FALSE;
    }


    //Row 3 nb same x and y as row 1 different z's
    for (loop1=28;loop1<=40;loop1++)
    {    
        Wall[loop1].TopLeftX=Wall[loop1-27].TopLeftX;         Wall[loop1].TopLeftY=Wall[loop1-27].TopLeftY;
        Wall[loop1].TopRightX=Wall[loop1-27].TopRightX;       Wall[loop1].TopRightY=Wall[loop1-27].TopRightY;
        Wall[loop1].BottomLeftX=Wall[loop1-27].BottomLeftX;   Wall[loop1].BottomLeftY=Wall[loop1-27].BottomLeftY;
        Wall[loop1].BottomRightX=Wall[loop1-27].BottomRightX; Wall[loop1].BottomRightY=Wall[loop1-27].BottomRightY;

        Wall[loop1].Thickness=0.5f;
        Wall[loop1].BrickCleared=FALSE;
        Wall[loop1].Depth=-6.5f;
    }

    for (loop1=1;loop1<=13;loop1++)
    {
        Wall[loop1].colour=7;
        Wall[loop1].special=0;
    }

    for (loop1=14;loop1<=27;loop1++)
    {
        Wall[loop1].colour=5;
        Wall[loop1].special=0;
    }
    for (loop1=28;loop1<=40;loop1++)
    {
        Wall[loop1].colour=6;
        Wall[loop1].special=0;
    }
    
        
    for (loop1=1;loop1<=40;loop1++)
    {
            Wall[loop1].Moving=false;           
            Wall[loop1].dx=0.0f;
            Wall[loop1].dy=0.0f;      
    }    

    if(index==1)//Background1
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=6;           
        }
    }

    if(index==2)//Background2
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].colour=25;           
        }

        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=25l;           
        }
 
        for (loop1=1;loop1<=27;loop1++)
        {
            Wall[loop1].colour=26;           
        }
    }

    if(index==15)//Background3
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].colour=29;           
        }

        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=29;           
        }
 
        for (loop1=1;loop1<=27;loop1++)
        {
            Wall[loop1].colour=28;           
        }
    }

    if(index==16)//Background1
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=21;           
        }
    }

    if(index==17)//Background1
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=30;           
        }
    }

    if(index==18)//Background3
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].colour=24;           
        }

        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=24;           
        }
 
        for (loop1=1;loop1<=27;loop1++)
        {
            Wall[loop1].colour=24;           
        }
    }

    if(index==19)//Background1
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].colour=22;           
        }
    }

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : MODIFY   BRICK ARRAY                                         //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ModifyBrickArray(void)
{
   
    if(level==1)//is it level 1
    {
        for (loop1=1;loop1<=27;loop1++)
        {
            Wall[loop1].BrickCleared=true;
        }
    }

    if(level==2)//is it level 2
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].BrickCleared=true;
        }
    }

    //NB level 3 has all bricks populated

    if((level==4)||(level%NumberOfLevels==4))
    {
        Rad=rand()%12+1;
        Wall[Rad].special=int(rand()%5+1);
        Wall[Rad].colour=9;

        Rad=rand()%14+14;
        Wall[Rad].special=int(rand()%5+1);
        Wall[Rad].colour=9;

        Rad=rand()%12+28;
        Wall[Rad].special=int(rand()%5+1);
        Wall[Rad].colour=9;
    }
    
    if((level==5)||(level%NumberOfLevels==5))
    {

        Rad=rand()%12+1;
        Wall[Rad].special=int(rand()%5+1);
        Wall[Rad].colour=9;

        Rad=rand()%14+14;
        Wall[Rad].special=int(rand()%5+1);
        Wall[Rad].colour=9;

        Rad=rand()%12+28;
        Wall[Rad].special=int(rand()%5+1);
        Wall[Rad].colour=9;    


        Rad2=rand()%12+1;
        Wall[Rad2].special=int(rand()%5+1);
        Wall[Rad2].colour=9;

        Rad2=rand()%14+14;
        Wall[Rad2].special=int(rand()%5+1);
        Wall[Rad2].colour=9;

        Rad2=rand()%12+28;
        Wall[Rad2].special=int(rand()%5+1);
        Wall[Rad2].colour=9;
   
    }

    if((level==6)||(level%NumberOfLevels==6))
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].BrickCleared=true;
        }        
        
        Wall[7].BrickCleared=false;
        Wall[7].Moving=true;
        Wall[7].Depth=-9.0f;
        Wall[7].dx=0.01f;//float(((rand()%10)-20)/10);
        Wall[7].dy=0.01f;//float(((rand()%10)-20)/10);
//      Wall[7].dz=float(((rand()%10)-20)/100);

        Wall[21].BrickCleared=false;
        Wall[21].Moving=true;
        Wall[21].Depth=-7.5f;
        Wall[21].dx=-0.015f;//float(((rand()%10)-20)/10);
        Wall[21].dy=-0.005f;//float(((rand()%10)-20)/10);
//      Wall[21].dz=float(((rand()%10)-20)/100);

        Wall[34].BrickCleared=false;
        Wall[34].Moving=true;
        Wall[34].Depth=-6.0f;
        Wall[34].dx=0.01f;//float(((rand()%10)-20)/10);
        Wall[34].dy=-0.005f;//float(((rand()%10)-20)/10);
//      Wall[34].dz=float(((rand()%10)-20)/100);         
    }
        
    if((level==7)||(level%NumberOfLevels==7))
    {
        for (loop1=1;loop1<=40;loop1++)                
        {
            Wall[loop1].special=int(rand()%5+1);

            if(Wall[loop1].special==4)
            {
                Wall[loop1].special=2;
            }
    
            Wall[loop1].colour=9;    
        }
    }

    if((level==8)||(level%NumberOfLevels==8))
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].BrickCleared=true;
        }        
        
        Wall[7].BrickCleared=false;
        Wall[7].Moving=true;
        Wall[7].dx=0.01f;//float(((rand()%10)-20)/10);
        Wall[7].dy=0.01f;//float(((rand()%10)-20)/10);
        Wall[7].special=int(rand()%5+1);
        Wall[7].colour=9; 
//      Wall[7].dz=float(((rand()%10)-20)/100);

        Wall[21].BrickCleared=false;
        Wall[21].Moving=true;
        Wall[21].dx=-0.015f;//float(((rand()%10)-20)/10);
        Wall[21].dy=-0.005f;//float(((rand()%10)-20)/10);
        Wall[21].special=int(rand()%5+1);
        Wall[21].colour=9;
//      Wall[21].dz=float(((rand()%10)-20)/100);

        Wall[34].BrickCleared=false;
        Wall[34].Moving=true;
        Wall[34].dx=0.01f;//float(((rand()%10)-20)/10);
        Wall[34].dy=-0.005f;//float(((rand()%10)-20)/10);
        Wall[34].special=int(rand()%5+1);
        Wall[34].colour=9;
//      Wall[34].dz=float(((rand()%10)-20)/100);         
    }

    if((level==9)||(level%NumberOfLevels==9))
    {
        for (loop1=14;loop1<=40;loop1++)
        {
            Wall[loop1].BrickCleared=true;
        }

        Wall[7].BrickCleared=false;
        Wall[7].Moving=true;
        Wall[7].dx=0.01f;//float(((rand()%10)-20)/10);
        Wall[7].dy=0.01f;//float(((rand()%10)-20)/10);
        Wall[7].special=int(rand()%5+1);
        Wall[7].colour=9;
        Wall[7].Depth+=0.5; 
//      Wall[7].dz=float(((rand()%10)-20)/100);

        Wall[21].BrickCleared=false;
        Wall[21].Moving=true;
        Wall[21].dx=-0.015f;//float(((rand()%10)-20)/10);
        Wall[21].dy=-0.005f;//float(((rand()%10)-20)/10);
        Wall[21].special=int(rand()%5+1);
        Wall[21].colour=9;
        Wall[21].Depth+=0.5;
//      Wall[21].dz=float(((rand()%10)-20)/100);

        Wall[34].BrickCleared=false;
        Wall[34].Moving=true;
        Wall[34].dx=0.01f;//float(((rand()%10)-20)/10);
        Wall[34].dy=-0.005f;//float(((rand()%10)-20)/10);
        Wall[34].special=int(rand()%5+1);
        Wall[34].colour=9;
        Wall[34].Depth+=0.5;
//      Wall[34].dz=float(((rand()%10)-20)/100);        
    }

    if((level==10)||(level%NumberOfLevels==10))
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].Depth+=1.5f;
        }
        
    }

    if((level==11)||(level%NumberOfLevels==11))
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].Depth+=1.5f;
            Wall[loop1].Depth+=float(((rand()%4)-2)*0.5f);
        }
        
    }

    if((level==12)||(level%NumberOfLevels==12))
    {
        for (loop1=1;loop1<=40;loop1++)
        {
            Wall[loop1].Depth+=2.5f;
        }
        
    }

    if((level==13)||(level%NumberOfLevels==13))
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].Depth=-9.5f;
        }

        for (loop1=14;loop1<=40;loop1++)
        {
            Wall[loop1].BrickCleared=true;
        }

        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].Depth+=float(loop1*0.5f);
        }
        
    }

    if((level==14)||(level%NumberOfLevels==14))
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].Depth=-9.0f;
        }

        for (loop1=14;loop1<=27;loop1++)
        {
            Wall[loop1].Depth=-7.0f;
            Wall[loop1].special=int(rand()%5+1);
            Wall[loop1].colour=9;
        }

        for (loop1=28;loop1<=40;loop1++)
        {
            Wall[loop1].Depth=-5.0f;
        }

            Wall[6].BrickCleared=true;
            Wall[7].BrickCleared=true;
            Wall[8].BrickCleared=true;
            Wall[20].BrickCleared=true;
            Wall[21].BrickCleared=true;
            Wall[33].BrickCleared=true;
            Wall[34].BrickCleared=true;
            Wall[35].BrickCleared=true;
        
    }

    if((level==15)||(level%NumberOfLevels==15))
    {
        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].Depth=-9.5f;
        }

        for (loop1=14;loop1<=27;loop1++)
        {
            Wall[loop1].Depth=-9.0f;
            Wall[loop1].special=int(rand()%5+1);
            Wall[loop1].colour=9;
        }

        for (loop1=28;loop1<=40;loop1++)
        {
            Wall[loop1].Depth=-8.5f;
        }

        for (loop1=1;loop1<=13;loop1++)
        {
            Wall[loop1].Depth+=float(loop1*0.5f);
        }

        for (loop1=14;loop1<=27;loop1++)
        {
            Wall[loop1].Depth+=float((loop1-13)*0.5f);
        }

        for (loop1=28;loop1<=40;loop1++)
        {
            Wall[loop1].Depth+=float((loop1-27)*0.5f);
        }
       
    }

}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                 FUNCTION : MOVE BRICKS                                                     //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
void MoveBricks(int BrickNo)
{
    //X
    if((Wall[BrickNo].BottomLeftX>-2.7f)&&(Wall[BrickNo].BottomRightX<2.7))
    {
        Wall[BrickNo].BottomLeftX+=Wall[BrickNo].dx*OverallSpeed;
        Wall[BrickNo].BottomRightX+=Wall[BrickNo].dx*OverallSpeed;
        Wall[BrickNo].TopLeftX+=Wall[BrickNo].dx*OverallSpeed;
        Wall[BrickNo].TopRightX+=Wall[BrickNo].dx*OverallSpeed;
    }   
    else
    {
        Wall[BrickNo].dx=-Wall[BrickNo].dx;
        Wall[BrickNo].BottomLeftX+=Wall[BrickNo].dx*OverallSpeed;
        Wall[BrickNo].BottomRightX+=Wall[BrickNo].dx*OverallSpeed;
        Wall[BrickNo].TopLeftX+=Wall[BrickNo].dx*OverallSpeed;
        Wall[BrickNo].TopRightX+=Wall[BrickNo].dx*OverallSpeed;
    }

    //Y
    if((Wall[BrickNo].BottomLeftY>-2.0f)&&(Wall[BrickNo].TopLeftY<2.0))
    {
        Wall[BrickNo].BottomLeftY+=Wall[BrickNo].dy*OverallSpeed;
        Wall[BrickNo].BottomRightY+=Wall[BrickNo].dy*OverallSpeed;
        Wall[BrickNo].TopLeftY+=Wall[BrickNo].dy*OverallSpeed;
        Wall[BrickNo].TopRightY+=Wall[BrickNo].dy*OverallSpeed;
    }
    else
    {
        Wall[BrickNo].dy=-Wall[BrickNo].dy;
        Wall[BrickNo].BottomLeftY+=Wall[BrickNo].dy*OverallSpeed;
        Wall[BrickNo].BottomRightY+=Wall[BrickNo].dy*OverallSpeed;
        Wall[BrickNo].TopLeftY+=Wall[BrickNo].dy*OverallSpeed;
        Wall[BrickNo].TopRightY+=Wall[BrickNo].dy*OverallSpeed;
    }
    
}
        

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                 FUNCTION : CHECK FOR BRICK COLLISION                                       //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void CheckForBrickCollision(void)
{
    for (loop1=1;loop1<=40;loop1++)
    {
        if ((ball.z>=Wall[loop1].Depth-Wall[loop1].Thickness)&&(ball.z<=Wall[loop1].Depth))
        {
            if (!Wall[loop1].BrickCleared)
            {
                if ((ball.x>=Wall[loop1].TopLeftX)&&
                    (ball.x<=Wall[loop1].TopRightX)&&
                    (ball.y>=Wall[loop1].BottomLeftY)&&
                    (ball.y<=Wall[loop1].TopLeftY))
                {
                    if (Wall[loop1].special!=0)
                    {
                        
                        PlaySound("Data/SOUND50.wav", NULL , SND_ASYNC);

                        if (Wall[loop1].special==1)
                        {
                            MultiBall=1000;
                        }                          
                        if (Wall[loop1].special==2)
                        {
                            FastBall=1000;
                        }
                        if (Wall[loop1].special==3)
                        {
                            SlowBall=1000;
                        }
                        if (Wall[loop1].special==4)
                        {
                            AddBrick=1000;
                        }
                        if (Wall[loop1].special==5)
                        {
                            MinusBrick=1000;
                        }
                        if (Wall[loop1].special==6)
                        {
                            Gun=1000;
                        }
                    }
                    else
                    {
                        PlaySound("Data/ding.wav", NULL, SND_ASYNC);
                    }
                    
                    Wall[loop1].BrickCleared=TRUE;
                    
                    if (MultiBall>0)
                    {
                        ball.dz=ball.dz*0.99f;    
                    }
                    else
                    {
                        ball.dz=-ball.dz*0.99f;

                        if((level==7)||(level%NumberOfLevels==7))
                        {                    
                            ball.dz*=1.05f;
                        }
                    }
                    

                        

                    Score+=10+100*NoOfBricksHit;
                    NoOfBricksHit++;       
                    BrickHit=true;
                    Count=0;//placed within create new particle
                    Brick=loop1;
                }
            }
        }
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                 FUNCTION : IS PARTICLE LIVE?                                               //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool IsParticleLive(int iparticle)
{
    //Used for debugging
    if (particle[iparticle].active)
    {return true;}
    else
    {return false;}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                 FUNCTION : INITIALISE PARTICLES                                            //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Called as game initialises and if game over occurs or life lost

void InitialiseParticles()
{
    for (loop1=0;loop1<MAX_PARTICLES;loop1++)					// Initials All The Textures
	{
        //Initialise particles
		particle[loop1].texture=8;
        particle[loop1].active=false;					        // Make All The Particles Active
		particle[loop1].life=1.0f;				            	// Give All The Particles Full Life

		particle[loop1].dx=0.0f;
		particle[loop1].dy=0.0f;                        		// Random Speed On Y Axis
		particle[loop1].dz=0.0f;                        		// Random Speed On Z Axis

//		particle[loop1].dx=float(((rand()%50)-25.0f)/50);

		particle[loop1].x=0.0f;
		particle[loop1].y=0.0f;
		particle[loop1].z=0.0f;

		particle[loop1].xg=0.0f;						        // Set Horizontal Pull To Zero
		particle[loop1].yg=-0.025f;		            			// Set Vertical Pull Downward
		particle[loop1].zg=0.0f;					        	// Set Pull On Z Axis To Zero

        particle[loop1].size=1;

	}
}



////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                      FUNCTION : AGE PARTICLE                                               //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
void AgeParticle(int iparticle)
{
    //Fade particles (age each particle the same)
    if (particle[iparticle].life>0)
    { 
        particle[iparticle].life-=0.005f;
    
        //Kill particle if its dead             
        if (particle[iparticle].life<0)
        {
            particle[iparticle].active=false;
            test5++;
        }
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : DISPLACE PARTICLE                                             //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void DisplaceParticle(int iparticle)
{
    //Move particles
	particle[iparticle].x+=particle[iparticle].dx/100*OverallSpeed;	// Move On The X Axis By X Speed
	particle[iparticle].y+=particle[iparticle].dy/100*OverallSpeed;	// Move On The Y Axis By Y Speed
	particle[iparticle].z+=particle[iparticle].dz/100*OverallSpeed;	// Move On The Z Axis By Z Speed

	particle[iparticle].dx+=particle[iparticle].xg;			// Take Pull On X Axis Into Account
	particle[iparticle].dy+=particle[iparticle].yg;			// Take Pull On Y Axis Into Account
	particle[iparticle].dz+=particle[iparticle].zg;			// Take Pull On Z Axis Into Account   
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : DECELERATE PARTICLE                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void DecelerateParticle(int iparticle)
{
    //Decelerate particles
   	particle[iparticle].dx=0.99f*particle[iparticle].dx;			// Take Pull On X Axis Into Account
	particle[iparticle].dy=0.99f*particle[iparticle].dy;			// Take Pull On Y Axis Into Account
	particle[iparticle].dz=0.99f*particle[iparticle].dz;			// Take Pull On Z Axis Into Account      
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : CREATE NEW PARTICLE                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CreateNewParticle()                
{
    //ESSENTIALLY THIS ROUTINE IS CALLED FROM THE MAIN LOOP IN WINMAIN EACH GAME CYCLE
    //THEN THE PARTICLES ARE <DISPLACED>,<REFLECTED>,<AGED> IN THAT ORDER

    //HAVE 2000 PARTICLES

    //0-999         FOR BRICK EXPLOSIONS
    //1000-1499     FOR BALL/WALL COLLISIONS
    //1500-1999     FOR TRAILLING THE BALL    

    //NB Brick HOLDS INDEX TO RELEVANT BRICK IN Wall[]

    //NB2 Count set to 0 and BrickHit set to TRUE in check for brick collision    

    //BRICK PARTICLES

    if (BrickHit)//Only create particles at brick if BrickHit is true 
    {
         
        for (loop1=0;loop1<1000;loop1++)//only use the 1st 1000 particles for brick explosions
        {
            if ((particle[loop1].active==false)&&BrickHit)//Check particle not already in use
            {
                particle[loop1].active=true;//Make active again if inactive
		        //particle[loop1].life=float((rand()%20-10)/10);				// Give It New Life in the range 1.0 +/- 0.1
		        particle[loop1].life=float(1.0f+(rand()%20-10)/15);            

                //Create particle within current "Hit" brick
	        	particle[loop1].x=float(Wall[Brick].BottomLeftX+(rand()%100)/(100*(Wall[Brick].BottomRightX-Wall[Brick].BottomLeftX)));					// Center On X Axis
	        	particle[loop1].y=float(Wall[Brick].BottomLeftY+(rand()%100)/(100*(Wall[Brick].TopLeftY-Wall[Brick].BottomLeftY)));					// Center On Y Axis
		        particle[loop1].z=float(Wall[Brick].Depth-(rand()%100)/100*Wall[Brick].Thickness);
                //Give particle texture of current brick
                particle[loop1].texture=Wall[Brick].colour;
                //Give particle random velocity
                particle[loop1].dx=float(Pvelocity*((rand()%100)-50.0f)/30);		// Random Speed On X Axis
                particle[loop1].dy=float(Pvelocity*((rand()%100)-50.0f)/30);		// Random Speed On Y Axis
                particle[loop1].dz=float(Pvelocity*((rand()%150))/30);

                particle[loop1].size=1+rand()%5;
                //If 100 particles have been created at brick set brick hit to false
                Count++;
                if (Count==Pdensity)
                {
                    BrickHit=false;
                    Count=0;
                }
            
                test++;
            

            }
        }
    }

    //BALL PARTICLES
    Count=0;

    
        
        for (loop1=1000;loop1<1500;loop1++)             
        {
            if ((particle[loop1].active==false)&&(Count<3))
            {     

                particle[loop1].yg=-0.005f;
    
                particle[loop1].active=true;//Make active again if inactive
                particle[loop1].life=float(0.75f+(rand()%25)/100);             

                particle[loop1].x=float(ball.x+(((rand()%200)-100)/100)*BallThickness);
                particle[loop1].y=float(ball.y+(((rand()%200)-100)/100)*BallThickness);
                particle[loop1].z=ball.z;

                particle[loop1].dx=float(((rand()%100)-50.0f)/300);
                particle[loop1].dy=float(((rand()%100)-50.0f)/300);
                particle[loop1].dz=float(((rand()%100)-50.0f)/300);

                if(rand()%10>9)
                {
                    //particle[loop1].dy=float(((rand()%100)-50.0f));
                    particle[loop1].dz=-ball.dz;
                    particle[loop1].dx=float(((rand()%100)-50.0f)/100);
                    particle[loop1].dy=float(((rand()%100)-50.0f)/100);
 
                }

                if(rand()%10>9)
                {
                    //particle[loop1].dx=float(((rand()%100)-50.0f));
                    particle[loop1].dz=1.5f*ball.dz;
                    particle[loop1].dy=float(((rand()%100)-50.0f)/50);
                    particle[loop1].dz=float(((rand()%100)-50.0f)/50);
                }

                if (MultiBall>0)
                {
                    particle[loop1].texture=10;
                    Count++;
                }
                else
                {                 
                    if (Count==0)
                    {
                        particle[loop1].texture=3;
                    }

                    if (Count==1)
                    {
                        particle[loop1].texture=3;
                    }        

                    if (Count==2)
                    {
                        particle[loop1].texture=3;                                                
                    }

                    Count++;
                }
            }
        }
    
    //BALL/WALL COLLISIONS

    if (WallHit)
    {
        for (loop1=1500;loop1<2000;loop1++)             
        {
            if ((particle[loop1].active==false)&&(WallHit==true))
            {     
                particle[loop1].active=true;//Make active again if inactive
                particle[loop1].life=float(0.5f+(rand()%20-10)/100);				// Give It New Life in the range 1.0 +/- 0.1             

                particle[loop1].x=ball.x;
                particle[loop1].y=ball.y;
                particle[loop1].z=ball.z;

                particle[loop1].dx=float(((rand()%100)-50.0f)/25);
                particle[loop1].dy=float(((rand()%100)-50.0f)/25);
                particle[loop1].dz=float(((rand()%100)-50.0f)/25);

                particle[loop1].texture=index;

                Count++;
                if (Count==100)
                {
                    WallHit=false;
                    Count=0;
                }

            }
        }
    }


           
    //Bat
    Count=0;        

//    if(BatHit)
    {    
        for(loop1=2000;loop1<2500;loop1++)             
        {

            if ((particle[loop1].active==false)&&(Count<500))
            {     
                
                particle[loop1].size=3;
                particle[loop1].texture=13;

                if(ball.z<-5.5f)
                {
                    particle[loop1].texture=10;                    
                }

                if(Count==0)
                {
                    //Top
                    particle[loop1].yg=-0.015f;

                    particle[loop1].active=true;//Make active again if inactive
                    particle[loop1].life=float(0.75f+(rand()%25)/100);             

                    particle[loop1].x=float(bat.x+0.7f*((rand()%200)-100)/100);
                    particle[loop1].y=0.5f+bat.y;
                    particle[loop1].z=bat.z;

                    particle[loop1].dx=0.0f;
                    particle[loop1].dy=0.0f;
                    particle[loop1].dz=0.0f;

                }

                if(Count==1)
                {
                    //Bottom
                    particle[loop1].yg=-0.005f;

                    particle[loop1].active=true;//Make active again if inactive
                    particle[loop1].life=float(0.75f+(rand()%25)/100);             

                    particle[loop1].x=float(bat.x+0.7f*((rand()%200)-100)/100);
                    particle[loop1].y=-0.5f+bat.y;
                    particle[loop1].z=bat.z;

                    particle[loop1].dx=0.0f;
                    particle[loop1].dy=0.0f;
                    particle[loop1].dz=0.0f;

                }

                if(Count==2)
                {
                    //Right
                    particle[loop1].yg=-0.005f;

                    particle[loop1].active=true;//Make active again if inactive
                    particle[loop1].life=float(0.75f+(rand()%25)/100);             

                    particle[loop1].x=0.7f+bat.x;
                    particle[loop1].y=float(bat.y+0.5f*((rand()%200)-100)/100);
                    particle[loop1].z=bat.z;

                    particle[loop1].dx=0.0f;
                    particle[loop1].dy=0.0f;
                    particle[loop1].dz=0.0f;

                }

                if(Count==3)
                {
                    //Bottomleft
                    particle[loop1].yg=-0.005f;

                    particle[loop1].active=true;//Make active again if inactive
                    particle[loop1].life=float(0.75f+(rand()%25)/100);             

                    particle[loop1].x=-0.7f+bat.x;
                    particle[loop1].y=float(bat.y+0.5f*((rand()%200)-100)/100);
                    particle[loop1].z=bat.z;

                    particle[loop1].dx=0.0f;
                    particle[loop1].dy=0.0f;
                    particle[loop1].dz=0.0f;

                }

                Count++;

                if (Count==499)
                {
                    BatHit=false;
                    Count=0;
                }                



            }


        }

    }
}    
/*
         else//Create particle at ball 
         {
            particle[loop1].active=true;//Make active again if inactive
            particle[loop1].life=1.0f;				// Give It New Life
            //Default Texture 
            particle[loop1].texture=8;
            //Give particle balls position
 		    particle[loop1].x=ball.x;					// Center On X Axis
		    particle[loop1].y=ball.y;					// Center On Y Axis
		    particle[loop1].z=ball.z-5.0f;					// Center On Z Axis
            //Default velocity to zero
      		particle[loop1].dx=0.0;// X Axis Speed And Direction
	    	particle[loop1].dy=0.0;// Y Axis Speed And Direction
	    	particle[loop1].dz=0.0;// Z Axis Speed And Direction

            test2++;
            
            

         }

	
}*/

/*

void CreateNewParticle(int iparticle)
{
    //Is particle burned out or inactive?
	if (particle[iparticle].active==false)				
	{
        test4++;
		particle[iparticle].fade=float(rand()%100)/1000.0f+0.003f;	// Random Fade Value
            

        if (BrickHit)//Only odd particles created at brick 
        {
            particle[iparticle].active=true;//Make active again if inactive
		    particle[iparticle].life=1.0f;				// Give It New Life
            //Create particle within current "Hit" brick
	    	particle[iparticle].x=Wall[Brick].BottomLeftX+(rand()%100)/100*(Wall[Brick].BottomRightX-Wall[Brick].BottomLeftX);					// Center On X Axis
	    	particle[iparticle].y=Wall[Brick].BottomLeftY+(rand()%100)/100*(Wall[Brick].TopLeftY-Wall[Brick].BottomLeftY);					// Center On Y Axis
		    particle[iparticle].z=Wall[Brick].Depth-(rand()%100)/100*Wall[Brick].Thickness;
            //Give particle texture of current brick
            particle[iparticle].texture=Wall[Brick].colour;
            //Give particle random velocity
            particle[iparticle].dx=float(((rand()%100)-50.0f)/100);		// Random Speed On X Axis
            particle[iparticle].dy=float(((rand()%100)-50.0f)/100);		// Random Speed On Y Axis
            particle[iparticle].dz=float(((rand()%100)-50.0f)/100);
            //If 1000 particles have been created at brick set brick hit to false
            Count++;
            if (Count>1000)
            {
                BrickHit=false;
            }
            
            test++;
            

         }
         else//Create particle at ball 
         {
            particle[iparticle].active=true;//Make active again if inactive
            particle[iparticle].life=1.0f;				// Give It New Life
            //Default Texture 
            particle[iparticle].texture=8;
            //Give particle balls position
 		    particle[iparticle].x=ball.x;					// Center On X Axis
		    particle[iparticle].y=ball.y;					// Center On Y Axis
		    particle[iparticle].z=ball.z-5.0f;					// Center On Z Axis
            //Default velocity to zero
      		particle[iparticle].dx=0.0;// X Axis Speed And Direction
	    	particle[iparticle].dy=0.0;// Y Axis Speed And Direction
	    	particle[iparticle].dz=0.0;// Z Axis Speed And Direction

            test2++;
            
            

         }

	}
}

*/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : REFLECT PARTICLE                                              //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ReflectParticle(int iparticle)
{
     //Particle hits left or right wall
     if ((particle[iparticle].x>2.7)||(particle[iparticle].x<-2.7))
     {
        particle[iparticle].dx=-particle[iparticle].dx;
     }
     //Particle hits ceiling or floor
     if ((particle[iparticle].y>2.0)||(particle[iparticle].y<-2.0))
     {
        particle[iparticle].dy=-particle[iparticle].dy;  
        
        if(particle[iparticle].y<-2.0)
        {
            particle[iparticle].dy*=0.75f;
        }
     }


     //Particle hits back wall
     if ((particle[iparticle].z<-10.0)&&(particle[iparticle].dz<0.0))
     {
        particle[iparticle].dz=-particle[iparticle].dz;
     }
     //Particle comes out of screen    
     if (particle[iparticle].z>5.0)
     {
        particle[iparticle].active=false;
     }
   
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : REFLECT PARTICLE 2                                            //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ReflectParticle2(int iparticle)
{
    for (loop2=1;loop2<40;loop2++)
    {      
        if(!Wall[loop2].BrickCleared)
        {
             //Particle hits left or right wall
             if ((particle[iparticle].x>Wall[loop2].BottomLeftX)||(particle[iparticle].x<Wall[loop2].BottomRightX))
             {
                particle[iparticle].dx=-particle[iparticle].dx;
             }
             //Particle hits ceiling or floor
             if ((particle[iparticle].y>Wall[loop2].TopRightY)||(particle[iparticle].y<Wall[loop2].BottomRightY))
             {
                particle[iparticle].dy=-particle[iparticle].dy;  
             }
             //Particle hits back wall
             if ((particle[iparticle].z<(Wall[loop2].Depth-Wall[loop2].Thickness))&&(particle[iparticle].dz<Wall[loop2].Depth))
             {
                particle[iparticle].dz=-particle[iparticle].dz;
             }
        }
    }
}   


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                   FUNCTION : EVOLVE WEAPONS                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void EvolveWeapons()
{
    //Age weapons
    MultiBall--;
    if (MultiBall<0) MultiBall=0;

    FastBall--;
    if (FastBall<0) FastBall=0;

    SlowBall--;
    if (SlowBall<0) SlowBall=0;

    Gun--;
    if (Gun<0) Gun=0;

    AddBrick--;
    if (AddBrick<0) AddBrick=0;

    MinusBrick--;
    if (MinusBrick<0) MinusBrick=0;


    //Activate Weapons
    if (MultiBall>0) {};//see check brick collision for multiball(superball)
    
    if (FastBall>0)
    {
        //Speed ball up
        ball.dz*=float(1.001);
        
        if (FastBall==1)
        {
            ball.dz=ball.dz/ABS(ball.dz)*1.25f;
        }
    }

    if (SlowBall>0)
    {
        //Slow ball down    
        ball.dz*=float(0.999);
        
        if (SlowBall==1)
        {
            ball.dz=ball.dz/ABS(ball.dz)*1.25f;
        }
    }

    if (Gun>0) {};// Do nothing hehe
        
    if (AddBrick>0)
    {
        if (AddBrick%100==0)//Only add 10 bricks per power up
        {
            
            PlaySound("data/SOUND999.wav", NULL, SND_ASYNC);

            //Replace First Cleared BrickFound            
            loop2=40;
            while((loop2>=1)&&(Wall[loop2].BrickCleared==false))
            {
                loop2--;
            }
            Wall[loop2].BrickCleared=false;

            
            
            if (rand()%(10-level%10)==1)//1 in 13 chance    
            {                             
                Wall[loop2].special=rand()%5+1;
                Wall[loop2].colour=9;            
            }
             
         }             
    }

    if (MinusBrick>0)
    {
        if (MinusBrick%100==0)
        {
            Score+=100;
            PlaySound("data/SOUND999.wav", NULL, SND_ASYNC);            

            //Remove First NonCleared BrickFound            
            loop1=40;
            while ((loop1>=1)&&(Wall[loop1].BrickCleared==true))
            {             
                loop1--;
            }
            Wall[loop1].BrickCleared=true;
         }             
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                      FUNCTION : LOAD BITMAPS                                               //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

AUX_RGBImageRec *LoadBMP(char *Filename)			        // Loads The Bitmap Images
{
		FILE *File=NULL;								    // File Handle
		if (!Filename)										// Make Sure A Filename Was Given
		{
			return NULL;									// If Not Return NULL
		}
		File=fopen(Filename,"r");							// Check To See If The File Exists
		if (File)											// Does The File Exist?
		{
			fclose(File);									// Close The Handle
			return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
		}
		return NULL;										// If Load Failed Return NULL
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION : LOAD TEXTURES                                             //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
          
int LoadGLTextures()										// Load Bitmaps And Convert To Textures
{
        int Status=FALSE;									// Status Indicator
        AUX_RGBImageRec *TextureImage[NumberOfTextures];					// Create Storage Space For The Textures
        memset(TextureImage,0,sizeof(void *)*NumberOfTextures);			// Set The Pointer To NULL

        if ((TextureImage[0]=LoadBMP("Data/Font.bmp")) &&	
			(TextureImage[1]=LoadBMP("Data/background.bmp")) &&
            (TextureImage[2]=LoadBMP("Data/background2.bmp")) &&
            (TextureImage[3]=LoadBMP("Data/ball.bmp"))	&&
            (TextureImage[4]=LoadBMP("Data/yellow.bmp")) &&	
            (TextureImage[5]=LoadBMP("Data/metal4.bmp")) &&
            (TextureImage[6]=LoadBMP("Data/metal3.bmp")) &&
            (TextureImage[7]=LoadBMP("Data/metal8.bmp")) &&
            (TextureImage[8]=LoadBMP("Data/bat.bmp")) &&
            (TextureImage[9]=LoadBMP("Data/metal1.bmp")) && //special
            (TextureImage[10]=LoadBMP("Data/particle.bmp")) &&
            (TextureImage[11]=LoadBMP("Data/dblue.bmp")) &&
            (TextureImage[12]=LoadBMP("Data/text.bmp")) &&
            (TextureImage[13]=LoadBMP("Data/ball2.bmp")) &&
            (TextureImage[14]=LoadBMP("Data/background4.bmp")) &&
            (TextureImage[15]=LoadBMP("Data/background5.bmp")) &&
            (TextureImage[16]=LoadBMP("Data/background6.bmp")) &&
            (TextureImage[17]=LoadBMP("Data/background7.bmp")) &&
            (TextureImage[18]=LoadBMP("Data/background8.bmp")) &&
            (TextureImage[19]=LoadBMP("Data/background9.bmp")) &&
            (TextureImage[20]=LoadBMP("Data/1ball.bmp")) &&                       //21
            (TextureImage[21]=LoadBMP("Data/Weird.bmp")) &&
            (TextureImage[22]=LoadBMP("Data/hole.bmp")) &&
            (TextureImage[23]=LoadBMP("Data/1ball.bmp")) &&
            (TextureImage[24]=LoadBMP("Data/stone1.bmp")) &&
            (TextureImage[25]=LoadBMP("Data/stone4.bmp")) &&
            (TextureImage[26]=LoadBMP("Data/stone5.bmp")) &&
            (TextureImage[27]=LoadBMP("Data/stone6.bmp")) &&
            (TextureImage[28]=LoadBMP("Data/matt.bmp")) &&
            (TextureImage[29]=LoadBMP("Data/matt2.bmp")) &&
            (TextureImage[30]=LoadBMP("Data/metal5.bmp")) &&
            (TextureImage[31]=LoadBMP("Data/red.bmp"))) 

                    //backgrounds Index     Brick Textures
                    //  1           1       Metal6,stone6,stone1    
                    //  2           2       Stone4,stone5
                    //  3           13
                    //  4           14      Metal3,4,8
                    //  5           15      Matt2,Matt
                    //  6           16      Wierd
                    //  7           17      Metal2
                    //  8           18      Stone1,tile
                    //  9           19      Hole
	
        {
			Status=TRUE;									// Set The Status To TRUE

			glGenTextures(NumberOfTextures, &texture[0]);					// Create The Texture

			for (loop1=0; loop1<NumberOfTextures; loop1++)					// Loop Through Textures
			{
				glBindTexture(GL_TEXTURE_2D, texture[loop1]);
				glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[loop1]->sizeX, TextureImage[loop1]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[loop1]->data);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			}

			for (loop1=0; loop1<NumberOfTextures; loop1++)					// Loop Through Textures
			{
				if (TextureImage[loop1])					// If Texture Exists	
				{
					if (TextureImage[loop1]->data)			// If Texture Image Exists
					{
						free(TextureImage[loop1]->data);	// Free The Texture Image Memory
					}
					free(TextureImage[loop1]);				// Free The Image Structure
				}
			}
		}
	return Status;											// Return The Status
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION : BUILD FONT                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GLvoid BuildFont(GLvoid)								// Build Our Font Display List
{
	float	cx;											// Holds Our X Character Coord
	float	cy;											// Holds Our Y Character Coord

	base=glGenLists(256);								// Creating 256 Display Lists
	glBindTexture(GL_TEXTURE_2D, texture[0]);			// Select Our Font Texture
	for (loop1=0; loop1<256; loop1++)						// Loop Through All 256 Lists
	{
		cx=float(loop1%16)/16.0f;						// X Position Of Current Character
		cy=float(loop1/16)/16.0f;						// Y Position Of Current Character

		glNewList(base+loop1,GL_COMPILE);				// Start Building A List
			glBegin(GL_QUADS);							// Use A Quad For Each Character
				glTexCoord2f(cx,1-cy-0.0625f);			// Texture Coord (Bottom Left)
				glVertex2i(0,0);						// Vertex Coord (Bottom Left)
				glTexCoord2f(cx+0.0625f,1-cy-0.0625f);	// Texture Coord (Bottom Right)
				glVertex2i(16,0);						// Vertex Coord (Bottom Right)
				glTexCoord2f(cx+0.0625f,1-cy);			// Texture Coord (Top Right)
				glVertex2i(16,16);						// Vertex Coord (Top Right)
				glTexCoord2f(cx,1-cy);					// Texture Coord (Top Left)
				glVertex2i(0,16);						// Vertex Coord (Top Left)
			glEnd();									// Done Building Our Quad (Character)
			glTranslated(10,0,0);						// Move To The Right Of The Character
		glEndList();									// Done Building The Display List
	}													// Loop Until All 256 Are Built
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                      FUNCTION : KILL FONT                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GLvoid KillFont(GLvoid)										// Delete The Font From Memory
{
	glDeleteLists(base,256);								// Delete All 256 Display Lists
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION : GL PRINT                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GLvoid glPrint(GLint x, GLint y, int set, const char *fmt, ...)	// Where The Printing Happens
{

	char		text[256];									// Holds Our String
	va_list		ap;											// Pointer To List Of Arguments

	if (fmt == NULL)										// If There's No Text
		return;												// Do Nothing

	va_start(ap, fmt);										// Parses The String For Variables
	    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);												// Results Are Stored In Text

	if (set>1)
	{
		set=1;
	}
	glBindTexture(GL_TEXTURE_2D, texture[0]);			// Select Our Font Texture
	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(0,640,0,480,-1,1);							// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
	glTranslated(x,y,0);								// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(text),GL_BYTE,text);			// Write The Text To The Screen
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : RESIZE GL SCENE                                              //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)			// Resize And Initialize The GL Window
{
	if (height==0)											// Prevent A Divide By Zero By
	{
		height=1;											// Making Height Equal One
	}

	glViewport(0,0,width,height);							// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glLoadIdentity();										// Reset The Projection Matrix

	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);								// Select The Modelview Matrix
	glLoadIdentity();										// Reset The Modelview Matrix
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                        FUNCTION : INIT GL                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int InitGL(GLvoid)											// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())									// Jump To Texture Loading Routine
	{
		return FALSE;										// If Texture Didn't Load Return FALSE
	}

	BuildFont();											// Build The Font

    glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

    glEnable(GL_LIGHTING);
    
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
	glEnable(GL_LIGHT1);								// Enable Light One

	glEnable(GL_BLEND);										// Enable Blending
//  glColor4f(1.0f,1.0f,1.0f,0.9f);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
//	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);		// Type Of Blending To Use

	return TRUE;											// Initialization Went OK
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                         FUNCTION : DRAW GL SCENE                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int DrawGLScene(GLvoid)										// Here's Where We Do All The Drawing
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear Screen And Depth Buffer
    glLoadIdentity();
    glTranslatef(0.0f,0.0f,-5.0f);
    glEnable(GL_TEXTURE_2D);

    if(GameOn)
    {
	    if (TimerCount==0)
        {
            Time1=TimerGetTime()/1000;                          // Time1 in sec : frame 0
        }
        else if (TimerCount==100)
        {
            Time2=TimerGetTime()/1000;                          // Time2 in sec : frame 100
            DiffTime=ABS(Time2-Time1);
            OverallSpeed=DiffTime*1.05f;                        // OverallSpeed time for 100 frames
        }
        TimerCount++;
    }

/*    if(!GameOn)
    {
        glEnable(GL_BLEND);
        glBindTexture(GL_TEXTURE_2D, texture[0]);
        glColor3f(1.0f,1.0f,1.0f);
        glPrint(270,430,1,"GAME OVER");

    }
*/
									// Reset The View
	glEnable(GL_BLEND);
    glEnable(GL_TEXTURE_2D);                                // glPrint() disables GL_TEXTURE_2D
	glBindTexture(GL_TEXTURE_2D, texture[12]);
	glBegin(GL_QUADS);
//	glColor3f(0.5f,0.5f,0.5f);


    if(!GameOn)
    {    
        if(Zoom<=0.0)
        {      
            for (loop1=1;loop1<50;loop1++)
            {       
                Zoom2=float(Zoom+((loop1-1)*0.2)+(rand()%200-100)/100);
                if (Zoom2>0.0)
                {
                    Zoom2=0.0;
                }
                
		        glNormal3f( 0.0f, 0.0f,1.0f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f(2.7f, -2.0f, Zoom2);
		        glTexCoord2f(0.0f, 0.0f); glVertex3f( -2.7f, -2.0f, Zoom2);
		        glTexCoord2f(0.0f, 1.0f); glVertex3f( -2.7f,  2.0f, Zoom2);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(2.7f,  2.0f, Zoom2);
            }                    
        }
    }

    glEnd();

    if(GameOn)
    {

	    glDisable(GL_BLEND);
        glEnable(GL_TEXTURE_2D);
	    glBindTexture(GL_TEXTURE_2D, texture[index]);
	    glBegin(GL_QUADS);

        // Draw Container

		// Back Wall
		glNormal3f( 0.0f, 0.0f,1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(2.7f, -2.0f, -10.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -2.7f, -2.0f, -10.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -2.7f,  2.0f, -10.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(2.7f,  2.0f, -10.0f);
		
        // Ceiling
		glNormal3f( 0.0f, -1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-2.7f,  2.0f,  -10.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-2.7f,  2.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.7f,  2.0f, 0.0f);
        glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.7f,  2.0f,  -10.0f);

		// Floor
		glNormal3f( 0.0f,1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(2.7f, -2.0f, -10.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(2.7f, -2.0f,  0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -2.7f, -2.0f,  0.0f);
        glTexCoord2f(0.0f, 1.0f); glVertex3f( -2.7f, -2.0f, -10.0f);
		
        // Right Wall
		glNormal3f( -1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 2.7f, -2.0f,  -10.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 2.7f,  2.0f,  -10.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.7f,  2.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.7f, -2.0f, 0.0f);
		
        // Left Wall
		glNormal3f(1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-2.7f, -2.0f, 0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-2.7f,  2.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-2.7f,  2.0f,  -10.0f);
        glTexCoord2f(1.0f, 0.0f); glVertex3f(-2.7f, -2.0f,  -10.0f);

    glEnd();

        //Draw Bat

        if(!Menu && !Instructions)//Dont draw bat if menu is on
        {
	    glBegin(GL_QUADS);

        glEnable(GL_BLEND);

        //Draw Bat Top
        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.7f + bat.x, 0.45f + bat.y, 0.0f + bat.z);//bottom right
		glVertex3f( -0.7f + bat.x, 0.45f + bat.y, 0.0f + bat.z);//bottom left
		glVertex3f( -0.7f + bat.x,  0.5f + bat.y, 0.0f + bat.z);//top left
		glVertex3f(0.7f + bat.x,  0.5f + bat.y, 0.0f + bat.z);//top right

        //Draw Bat Bottom
        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.7f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom right
		glVertex3f( -0.7f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom left
		glVertex3f( -0.7f + bat.x, -0.45f + bat.y, 0.0f + bat.z);//top left
		glVertex3f(0.7f + bat.x, -0.45f + bat.y, 0.0f + bat.z);//top right

        //Draw Bat Left
        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(-0.65f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom right
		glVertex3f( -0.7f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom left
		glVertex3f( -0.7f + bat.x, 0.5f + bat.y, 0.0f + bat.z);//top left
		glVertex3f(-0.65f + bat.x, 0.5f + bat.y, 0.0f + bat.z);//top right

        //Draw Bat Right
        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.65f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom right
		glVertex3f( 0.7f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom left
		glVertex3f( 0.7f + bat.x, 0.5f + bat.y, 0.0f + bat.z);//top left
		glVertex3f(0.65f + bat.x, 0.5f + bat.y, 0.0f + bat.z);//top right

        //Draw Bat Vertical Middle
        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.025f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom right
		glVertex3f(-0.025f + bat.x, -0.5f + bat.y, 0.0f + bat.z);//bottom left
		glVertex3f(-0.025f + bat.x, 0.5f + bat.y, 0.0f + bat.z);//top left
		glVertex3f(0.025f + bat.x, 0.5f + bat.y, 0.0f + bat.z);//top right

        //Draw Bat Horizontal Middle
        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.7f + bat.x, -0.025f + bat.y, 0.0f + bat.z);//bottom right
		glVertex3f(-0.7f + bat.x, -0.025f + bat.y, 0.0f + bat.z);//bottom left
		glVertex3f(-0.7f + bat.x, 0.025f + bat.y, 0.0f + bat.z);//top left
		glVertex3f(0.7f + bat.x, 0.025f + bat.y, 0.0f + bat.z);//top right

        //Bat prong 1

        //Prong top
        glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(-0.65f + bat.x,0.5f + bat.y,0.1f);//back right
		glVertex3f(-0.7f + bat.x,0.5f + bat.y,0.1f);//back left
		glVertex3f(-0.7f + bat.x,0.5f + bat.y,-0.5f);//front left
		glVertex3f(-0.65f + bat.x,0.5f + bat.y,-0.5f);//front right

        //Prong bottom
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(-0.65f + bat.x,0.45f + bat.y,0.1f);//back right
		glVertex3f(-0.7f + bat.x,0.45f + bat.y,0.1f);//back left
		glVertex3f(-0.7f + bat.x,0.45f + bat.y,-0.5f);//front left
		glVertex3f(-0.65f + bat.x,0.45f + bat.y,-0.5f);//front right

        //Prong left side
        glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(-0.7f + bat.x,0.5f + bat.y,0.1f);//back top
		glVertex3f(-0.7f + bat.x,0.5f + bat.y,-0.5f);//front top
		glVertex3f(-0.7f + bat.x,0.45f + bat.y,-0.5f);//front bottom
		glVertex3f(-0.7f + bat.x,0.45f + bat.y,0.1f);//back bottom

        //Prong right side
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(-0.65f + bat.x,0.5f + bat.y,0.1f);//back top
		glVertex3f(-0.65f + bat.x,0.5f + bat.y,-0.5f);//front top
		glVertex3f(-0.65f + bat.x,0.45f + bat.y,-0.5f);//front bottom
		glVertex3f(-0.65f + bat.x,0.45f + bat.y,0.1f);//back bottom

        //Bat prong 2

        //Prong top
        glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.7f + bat.x,0.5f + bat.y,0.1f);//back right
		glVertex3f(0.65f + bat.x,0.5f + bat.y,0.1f);//back left
		glVertex3f(0.65f + bat.x,0.5f + bat.y,-0.5f);//front left
		glVertex3f(0.7f + bat.x,0.5f + bat.y,-0.5f);//front right

        //Prong bottom
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.7f + bat.x,0.45f + bat.y,0.1f);//back right
		glVertex3f(0.65f + bat.x,0.45f + bat.y,0.1f);//back left
		glVertex3f(0.65f + bat.x,0.45f + bat.y,-0.5f);//front left
		glVertex3f(0.7f + bat.x,0.45f + bat.y,-0.5f);//front right

        //Prong left side
        glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(0.65f + bat.x,0.5f + bat.y,0.1f);//back top
		glVertex3f(0.65f + bat.x,0.5f + bat.y,-0.5f);//front top
		glVertex3f(0.65f + bat.x,0.45f + bat.y,-0.5f);//front bottom
		glVertex3f(0.65f + bat.x,0.45f + bat.y,0.1f);//back bottom

        //Prong right side
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.7f + bat.x,0.5f + bat.y,0.1f);//back top
		glVertex3f(0.7f + bat.x,0.5f + bat.y,-0.5f);//front top
		glVertex3f(0.7f + bat.x,0.45f + bat.y,-0.5f);//front bottom
		glVertex3f(0.7f + bat.x,0.45f + bat.y,0.1f);//back bottom

        //Bat prong 3

        //Prong top
        glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.7f + bat.x,-0.45f + bat.y,0.1f);//back right
		glVertex3f(0.65f + bat.x,-0.45f + bat.y,0.1f);//back left
		glVertex3f(0.65f + bat.x,-0.45f + bat.y,-0.5f);//front left
		glVertex3f(0.7f + bat.x,-0.45f + bat.y,-0.5f);//front right

        //Prong bottom
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.7f + bat.x,-0.5f + bat.y,0.1f);//back right
		glVertex3f(0.65f + bat.x,-0.5f + bat.y,0.1f);//back left
		glVertex3f(0.65f + bat.x,-0.5f + bat.y,-0.5f);//front left
		glVertex3f(0.7f + bat.x,-0.5f + bat.y,-0.5f);//front right

        //Prong left side
        glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(0.65f + bat.x,-0.45f + bat.y,0.1f);//back top
		glVertex3f(0.65f + bat.x,-0.45f + bat.y,-0.5f);//front top
		glVertex3f(0.65f + bat.x,-0.5f + bat.y,-0.5f);//front bottom
		glVertex3f(0.65f + bat.x,-0.5f + bat.y,0.1f);//back bottom

        //Prong right side
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.7f + bat.x,-0.45f + bat.y,0.1f);//back top
		glVertex3f(0.7f + bat.x,-0.45f + bat.y,-0.5f);//front top
		glVertex3f(0.7f + bat.x,-0.5f + bat.y,-0.5f);//front bottom
		glVertex3f(0.7f + bat.x,-0.5f + bat.y,0.1f);//back bottom

        //Bat prong 4

        //Prong top
        glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(-0.65f + bat.x,-0.45f + bat.y,0.1f);//back right
		glVertex3f(-0.7f + bat.x,-0.45f + bat.y,0.1f);//back left
		glVertex3f(-0.7f + bat.x,-0.45f + bat.y,-0.5f);//front left
		glVertex3f(-0.65f + bat.x,-0.45f + bat.y,-0.5f);//front right

        //Prong bottom
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(-0.65f + bat.x,-0.5f + bat.y,0.1f);//back right
		glVertex3f(-0.7f + bat.x,-0.5f + bat.y,0.1f);//back left
		glVertex3f(-0.7f + bat.x,-0.5f + bat.y,-0.5f);//front left
		glVertex3f(-0.65f + bat.x,-0.5f + bat.y,-0.5f);//front right

        //Prong left side
        glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(-0.7f + bat.x,-0.45f + bat.y,0.1f);//back top
		glVertex3f(-0.7f + bat.x,-0.45f + bat.y,-0.5f);//front top
		glVertex3f(-0.7f + bat.x,-0.5f + bat.y,-0.5f);//front bottom
		glVertex3f(-0.7f + bat.x,-0.5f + bat.y,0.1f);//back bottom

        //Prong right side
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(-0.65f + bat.x,-0.45f + bat.y,0.1f);//back top
		glVertex3f(-0.65f + bat.x,-0.45f + bat.y,-0.5f);//front top
		glVertex3f(-0.65f + bat.x,-0.5f + bat.y,-0.5f);//front bottom
		glVertex3f(-0.65f + bat.x,-0.5f + bat.y,0.1f);//back bottom	

        //Bat prong 5

        //Prong top
        glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.025f + bat.x,0.5f + bat.y,0.1f);//back right
		glVertex3f(-0.025f + bat.x,0.5f + bat.y,0.1f);//back left
		glVertex3f(-0.025f + bat.x,0.5f + bat.y,-0.1f);//front left
		glVertex3f(0.025f + bat.x,0.5f + bat.y,-0.1f);//front right

        //Prong bottom
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.025f + bat.x,0.45f + bat.y,0.1f);//back right
		glVertex3f(-0.025f + bat.x,0.45f + bat.y,0.1f);//back left
		glVertex3f(-0.025f + bat.x,0.45f + bat.y,-0.1f);//front left
		glVertex3f(0.025f + bat.x,0.45f + bat.y,-0.1f);//front right

        //Prong left side
        glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(-0.025f + bat.x,0.5f + bat.y,0.1f);//back top
		glVertex3f(-0.025f + bat.x,0.5f + bat.y,-0.1f);//front top
		glVertex3f(-0.025f + bat.x,0.45f + bat.y,-0.1f);//front bottom
		glVertex3f(-0.025f + bat.x,0.45f + bat.y,0.1f);//back bottom

        //Prong right side
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.025f + bat.x,0.5f + bat.y,0.1f);//back top
		glVertex3f(0.025f + bat.x,0.5f + bat.y,-0.1f);//front top
		glVertex3f(0.025f + bat.x,0.45f + bat.y,-0.1f);//front bottom
		glVertex3f(0.025f + bat.x,0.45f + bat.y,0.1f);//back bottom

        //Bat prong 6

        //Prong top
        glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.025f + bat.x,-0.45f + bat.y,0.1f);//back right
		glVertex3f(-0.025f + bat.x,-0.45f + bat.y,0.1f);//back left
		glVertex3f(-0.025f + bat.x,-0.45f + bat.y,-0.1f);//front left
		glVertex3f(0.025f + bat.x,-0.45f + bat.y,-0.1f);//front right

        //Prong bottom
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.025f + bat.x,-0.5f + bat.y,0.1f);//back right
		glVertex3f(-0.025f + bat.x,-0.5f + bat.y,0.1f);//back left
		glVertex3f(-0.025f + bat.x,-0.5f + bat.y,-0.1f);//front left
		glVertex3f(0.025f + bat.x,-0.5f + bat.y,-0.1f);//front right

        //Prong left side
        glNormal3f(-1.0f, 0.0f, 0.0f);
		glVertex3f(-0.025f + bat.x,-0.45f + bat.y,0.1f);//back top
		glVertex3f(-0.025f + bat.x,-0.45f + bat.y,-0.1f);//front top
		glVertex3f(-0.025f + bat.x,-0.5f + bat.y,-0.1f);//front bottom
		glVertex3f(-0.025f + bat.x,-0.5f + bat.y,0.1f);//back bottom

        //Prong right side
        glNormal3f(0.0f, -1.0f, 0.0f);
		glVertex3f(0.025f + bat.x,-0.45f + bat.y,0.1f);//back top
		glVertex3f(0.025f + bat.x,-0.45f + bat.y,-0.1f);//front top
		glVertex3f(0.025f + bat.x,-0.5f + bat.y,-0.1f);//front bottom
		glVertex3f(0.025f + bat.x,-0.5f + bat.y,0.1f);//back bottom

        //Prong Ends

        //Top left

        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(-0.7f + bat.x,0.5f + bat.y,0.1f);//Top left
		glVertex3f(-0.65f + bat.x,0.5f + bat.y,0.1f);//Top right
		glVertex3f(-0.65f + bat.x,0.45f + bat.y,0.1f);//Bottom right
		glVertex3f(-0.7f + bat.x,0.45f + bat.y,0.1f);//Bottom left

        //Top Right

        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.65f + bat.x,0.5f + bat.y,0.1f);//Top left
		glVertex3f(0.7f + bat.x,0.5f + bat.y,0.1f);//Top right
		glVertex3f(0.7f + bat.x,0.45f + bat.y,0.1f);//Bottom right
		glVertex3f(0.65f + bat.x,0.45f + bat.y,0.1f);//Bottom left

        //Bottom Right

        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.65f + bat.x,-0.45f + bat.y,0.1f);//Top left
		glVertex3f(0.7f + bat.x,-0.45f + bat.y,0.1f);//Top right
		glVertex3f(0.7f + bat.x,-0.5f + bat.y,0.1f);//Bottom right
		glVertex3f(0.65f + bat.x,-0.5f + bat.y,0.1f);//Bottom left

        //Bottom left

        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(-0.7f + bat.x,-0.45f + bat.y,0.1f);//Top left
		glVertex3f(-0.65f + bat.x,-0.45f + bat.y,0.1f);//Top right
		glVertex3f(-0.65f + bat.x,-0.5f + bat.y,0.1f);//Bottom right
		glVertex3f(-0.7f + bat.x,-0.5f + bat.y,0.1f);//Bottom left

        //Top Middle

        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(-0.025f + bat.x,0.5f + bat.y,0.1f);//Top left
		glVertex3f(0.025f + bat.x,0.5f + bat.y,0.1f);//Top right
		glVertex3f(0.025f + bat.x,0.45f + bat.y,0.1f);//Bottom right
		glVertex3f(-0.025f + bat.x,0.45f + bat.y,0.1f);//Bottom left

        //Bottom Middle

        glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(-0.025f + bat.x,-0.45f + bat.y,0.1f);//Top left
		glVertex3f(0.025f + bat.x,-0.45f + bat.y,0.1f);//Top right
		glVertex3f(0.025f + bat.x,-0.5f + bat.y,0.1f);//Bottom right
		glVertex3f(-0.025f + bat.x,-0.5f + bat.y,0.1f);//Bottom left

        glEnd();

        }


 




/*
    glBegin(GL_QUADS);




        // Draw Ball

		// Back 
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(ball.x+BallThickness,ball.y-BallThickness,ball.z-BallThickness);//bottom right
		glTexCoord2f(0.0f, 0.0f); glVertex3f(ball.x-BallThickness,ball.y-BallThickness,ball.z-BallThickness);//bottom left
		glTexCoord2f(0.0f, 1.0f); glVertex3f(ball.x-BallThickness,ball.y+BallThickness,ball.z-BallThickness);//top left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(ball.x+BallThickness,ball.y+BallThickness,ball.z-BallThickness);//top right
		
        // Top
		glNormal3f( 0.0f, 1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(ball.x-BallThickness,ball.y+BallThickness,ball.z-BallThickness);//back left
		glTexCoord2f(0.0f, 1.0f); glVertex3f(ball.x-BallThickness,ball.y+BallThickness,ball.z+BallThickness);//front left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(ball.x+BallThickness,ball.y+BallThickness,ball.z+BallThickness);//front right
        glTexCoord2f(1.0f, 0.0f); glVertex3f(ball.x+BallThickness,ball.y+BallThickness,ball.z-BallThickness);//back right

		// Bottom
		glNormal3f( 0.0f,-1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(ball.x+BallThickness,ball.y-BallThickness,ball.z-BallThickness);//back right
		glTexCoord2f(1.0f, 0.0f); glVertex3f(ball.x+BallThickness,ball.y-BallThickness,ball.z+BallThickness);//front right
		glTexCoord2f(0.0f, 0.0f); glVertex3f(ball.x-BallThickness,ball.y-BallThickness,ball.z+BallThickness);//front left
        glTexCoord2f(0.0f, 1.0f); glVertex3f(ball.x-BallThickness,ball.y-BallThickness,ball.z-BallThickness);//back left
		
        // Right Wall
		glNormal3f( 1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(ball.x+BallThickness,ball.y-BallThickness,ball.z+BallThickness);//back bottom
		glTexCoord2f(0.0f, 1.0f); glVertex3f(ball.x+BallThickness,ball.y+BallThickness,ball.z+BallThickness);//back top
		glTexCoord2f(1.0f, 1.0f); glVertex3f(ball.x+BallThickness,ball.y+BallThickness,ball.z-BallThickness);//front top
		glTexCoord2f(1.0f, 0.0f); glVertex3f(ball.x+BallThickness,ball.y-BallThickness,ball.z-BallThickness);//front bottom
		
        // Left Wall
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(ball.x-BallThickness,ball.y-BallThickness,ball.z+BallThickness);//front bottom
		glTexCoord2f(0.0f, 1.0f); glVertex3f(ball.x-BallThickness,ball.y+BallThickness,ball.z+BallThickness);//front top
		glTexCoord2f(1.0f, 1.0f); glVertex3f(ball.x-BallThickness,ball.y+BallThickness,ball.z-BallThickness);//back top
        glTexCoord2f(1.0f, 0.0f); glVertex3f(ball.x-BallThickness,ball.y-BallThickness,ball.z-BallThickness);//back bottom


		// Front
		glNormal3f( 0.0f, 0.0f,1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(ball.x+BallThickness,ball.y-BallThickness,ball.z+BallThickness);//bottom right
		glTexCoord2f(0.0f, 0.0f); glVertex3f(ball.x-BallThickness,ball.y-BallThickness,ball.z+BallThickness);//bottom left
		glTexCoord2f(0.0f, 1.0f); glVertex3f(ball.x-BallThickness,ball.y+BallThickness,ball.z+BallThickness);//top left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(ball.x+BallThickness,ball.y+BallThickness,ball.z+BallThickness);//top right

	glEnd();
*/	
	glColor3f(0.25f,0.25f,0.25f);


    
        //Draw Brick Wall	    	
        for (loop1=1;loop1<=40;loop1++)
        {
            //Only draw if not cleared
            if (!Wall[loop1].BrickCleared)
            {
                glEnable(GL_TEXTURE_2D); 
	            glBindTexture(GL_TEXTURE_2D, texture[Wall[loop1].colour]);

                if (Wall[loop1].colour==9)
                {
                   	glEnable(GL_BLEND);  
                }
                else
                {
                    glDisable(GL_BLEND);
                }

                glBegin(GL_QUADS);

                
		        // Back 
		        glNormal3f( 0.0f, 0.0f,-1.0f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f(Wall[loop1].BottomRightX,Wall[loop1].BottomRightY,Wall[loop1].Depth-Wall[loop1].Thickness);//bottom right
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(Wall[loop1].BottomLeftX,Wall[loop1].BottomLeftY,Wall[loop1].Depth-Wall[loop1].Thickness);//bottom left
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(Wall[loop1].TopLeftX,Wall[loop1].TopLeftY,Wall[loop1].Depth-Wall[loop1].Thickness);//top left
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(Wall[loop1].TopRightX,Wall[loop1].TopRightY,Wall[loop1].Depth-Wall[loop1].Thickness);//top right

                // Top
        		glNormal3f( 0.0f, 1.0f, 0.0f);
        		glTexCoord2f(0.0f, 0.0f); glVertex3f(Wall[loop1].TopLeftX,Wall[loop1].TopLeftY,Wall[loop1].Depth-Wall[loop1].Thickness);//back left
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(Wall[loop1].TopLeftX,Wall[loop1].TopLeftY,Wall[loop1].Depth);//front left
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(Wall[loop1].TopRightX,Wall[loop1].TopRightY,Wall[loop1].Depth);//front right
                glTexCoord2f(1.0f, 0.0f); glVertex3f(Wall[loop1].TopRightX,Wall[loop1].TopRightY,Wall[loop1].Depth-Wall[loop1].Thickness);//back right

		        // Bottom
		        glNormal3f( 0.0f,-1.0f, 0.0f);
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(Wall[loop1].BottomRightX,Wall[loop1].BottomRightY,Wall[loop1].Depth-Wall[loop1].Thickness);//back right
		        glTexCoord2f(1.0f, 0.0f); glVertex3f(Wall[loop1].BottomRightX,Wall[loop1].BottomRightY,Wall[loop1].Depth);//front right
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(Wall[loop1].BottomLeftX,Wall[loop1].BottomLeftY,Wall[loop1].Depth);//front left
                glTexCoord2f(0.0f, 1.0f); glVertex3f(Wall[loop1].BottomLeftX,Wall[loop1].BottomLeftY,Wall[loop1].Depth-Wall[loop1].Thickness);//back left

                // Right Wall
		        glNormal3f( 1.0f, 0.0f, 0.0f);
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(Wall[loop1].BottomRightX,Wall[loop1].BottomRightY,Wall[loop1].Depth-Wall[loop1].Thickness);//back bottom
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(Wall[loop1].TopRightX,Wall[loop1].TopRightY,Wall[loop1].Depth-Wall[loop1].Thickness);//back top
                glTexCoord2f(1.0f, 1.0f); glVertex3f(Wall[loop1].TopRightX,Wall[loop1].TopRightY,Wall[loop1].Depth);//front top
		        glTexCoord2f(1.0f, 0.0f); glVertex3f(Wall[loop1].BottomRightX,Wall[loop1].BottomRightY,Wall[loop1].Depth);//front bottom

                // Left Wall
		        glNormal3f(-1.0f, 0.0f, 0.0f);
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(Wall[loop1].BottomLeftX,Wall[loop1].BottomLeftY,Wall[loop1].Depth);//front bottom
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(Wall[loop1].TopLeftX,Wall[loop1].TopLeftY,Wall[loop1].Depth);//front top
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(Wall[loop1].TopLeftX,Wall[loop1].TopLeftY,Wall[loop1].Depth-Wall[loop1].Thickness);//back top
                glTexCoord2f(1.0f, 0.0f); glVertex3f(Wall[loop1].BottomLeftX,Wall[loop1].BottomLeftY,Wall[loop1].Depth-Wall[loop1].Thickness);//back bottom

                //Front face
        		glNormal3f( 0.0f, 0.0f,1.0f);
		        glTexCoord2f(1.0f, 0.0f); glVertex3f(Wall[loop1].BottomRightX,Wall[loop1].BottomRightY,Wall[loop1].Depth);//bottom right
		        glTexCoord2f(0.0f, 0.0f); glVertex3f(Wall[loop1].BottomLeftX,Wall[loop1].BottomLeftY,Wall[loop1].Depth);//bottom left
		        glTexCoord2f(0.0f, 1.0f); glVertex3f(Wall[loop1].TopLeftX,Wall[loop1].TopLeftY,Wall[loop1].Depth);//top left
		        glTexCoord2f(1.0f, 1.0f); glVertex3f(Wall[loop1].TopRightX,Wall[loop1].TopRightY,Wall[loop1].Depth);//top right
                
                glEnd();

            }
        }

    if(ball.dz<0.0f)
    {
        //DrawBall

        glColor3f(1.0f,1.0f,1.0f);

	    glBindTexture(GL_TEXTURE_2D, texture[3]);
        glEnable(GL_BLEND);

	    float x2=ball.x;				// Grab Our Particle X Position
	    float y2=ball.y;				// Grab Our Particle Y Position
	    float z2=ball.z;				// Particle Z 

	    glBegin(GL_TRIANGLE_STRIP);

            for(loop1=1;loop1<4;loop1++)
            {
                Zoom3=float(((rand()%2)-1)*(rand()%100)/1000);
    	        glTexCoord2d(1,1); glVertex3f(x2+BallThickness+Zoom3,y2+BallThickness+Zoom3,z2+Zoom3); // Top Right
	            glTexCoord2d(0,1); glVertex3f(x2-BallThickness+Zoom3,y2+BallThickness+Zoom3,z2+Zoom3); // Top Left
		        glTexCoord2d(1,0); glVertex3f(x2+BallThickness+Zoom3,y2-BallThickness+Zoom3,z2+Zoom3); // Bottom Right
		        glTexCoord2d(0,0); glVertex3f(x2-BallThickness+Zoom3,y2-BallThickness+Zoom3,z2+Zoom3); // Bottom Left
            }
	    glEnd();
      
        //DrawBallEnd    
    }

   	glDisable(GL_BLEND);

	for (loop1=0;loop1<MAX_PARTICLES;loop1++)					// Loop Through All The Particles
	{


		if ((TimerCount>100)&&(particle[loop1].active)&&Particles)					// If The Particle Is Active
		{
            glBindTexture(GL_TEXTURE_2D, texture[particle[loop1].texture]);//Bind particle texture

   	        glDisable(GL_BLEND);

            //put in blending for ball trail only
            //0-999         FOR BRICK EXPLOSIONS
            //1000-1499     FOR TRAILLING THE BALL
            //1500-1999     FOR BALL/WALL COLLISIONS 
           
            if(Wall[Brick].special!=0)
            {
                glEnable(GL_BLEND);
            }
            else
            {
                glDisable(GL_BLEND);                
            }

            if (((loop1<1500)&&(loop1>999))||((loop1>1999)&&(loop1<2500)))
            {
                glEnable(GL_BLEND);
            }

			float x=particle[loop1].x;				// Grab Our Particle X Position
			float y=particle[loop1].y;				// Grab Our Particle Y Position
			float z=particle[loop1].z;				// Particle Z 
         
   			// Draw The Particle Using Our RGB Values, Fade The Particle Based On It's Life
//    		glColor4f(particle[loop1].r,particle[loop1].g,particle[loop1].b,particle[loop1].life);
/*
	    	glBegin(GL_TRIANGLE_STRIP);
    	        glTexCoord2d(1,1); glVertex3f(x+0.0625f,y+0.0625f,z); // Top Right
	    	    glTexCoord2d(0,1); glVertex3f(x-0.0625f,y+0.0625f,z); // Top Left
			    glTexCoord2d(1,0); glVertex3f(x+0.0625f,y-0.0625f,z); // Bottom Right
			    glTexCoord2d(0,0); glVertex3f(x-0.0625f,y-0.0625f,z); // Bottom Left
		    glEnd();
*/

            Strip=float((0.025+(rand()%100)/100));

            if((loop1>1999)&&(loop1<2500))
            {
                Strip*=float(particle[loop1].size);
            }   

	    	glBegin(GL_TRIANGLE_STRIP);
    	        glTexCoord2d(1,1); glVertex3f(x+Strip,y+Strip,z); // Top Right
	    	    glTexCoord2d(0,1); glVertex3f(x-Strip,y+Strip,z); // Top Left
			    glTexCoord2d(1,0); glVertex3f(x+Strip,y-Strip,z); // Bottom Right
			    glTexCoord2d(0,0); glVertex3f(x-Strip,y-Strip,z); // Bottom Left
		    glEnd();
            
        }
    }

   	glEnable(GL_BLEND);
    
    if (ball.z>-3.0)
    {
        glBindTexture(GL_TEXTURE_2D, texture[3]);
    }
    else
    {
        glBindTexture(GL_TEXTURE_2D, texture[11]);
    }

    if(ball.dz>0.0f)
    {
        //DrawBall

        glColor3f(1.0f,1.0f,1.0f);

	    glBindTexture(GL_TEXTURE_2D, texture[3]);
        glEnable(GL_BLEND);

	    float x2=ball.x;				// Grab Our Particle X Position
	    float y2=ball.y;				// Grab Our Particle Y Position
	    float z2=ball.z;				// Particle Z 

	    glBegin(GL_TRIANGLE_STRIP);

            for(loop1=1;loop1<3;loop1++)
            {
                Zoom3=float(((rand()%2)-1)*(rand()%100)/1000);
    	        glTexCoord2d(1,1); glVertex3f(x2+BallThickness+Zoom3,y2+BallThickness+Zoom3,z2+Zoom3); // Top Right
	            glTexCoord2d(0,1); glVertex3f(x2-BallThickness+Zoom3,y2+BallThickness+Zoom3,z2+Zoom3); // Top Left
		        glTexCoord2d(1,0); glVertex3f(x2+BallThickness+Zoom3,y2-BallThickness+Zoom3,z2+Zoom3); // Bottom Right
		        glTexCoord2d(0,0); glVertex3f(x2-BallThickness+Zoom3,y2-BallThickness+Zoom3,z2+Zoom3); // Bottom Left
            }
	    glEnd();
      
        //DrawBallEnd    
    }

    if (ball.z>-5.5f)
    {
//        PlaySound("Data/SOUND136.wav", NULL, SND_ASYNC);

        glDisable(GL_BLEND);
	    glBindTexture(GL_TEXTURE_2D, texture[3]);

        glDisable(GL_TEXTURE_2D);
       
        glLineWidth(3.0f);

        Count=1;
        param1=0.05f;
        param2=0.00f;

        while((param1<1.0f)&&(param2<1.0f))
        { 
            
            glColor3f(1.0f,0.0f,0.0f);

            if(Count%2==0)
            {   
	            glBegin(GL_LINES);						// Start Drawing Our Player Using Lines

		            glVertex3d((-0.7f+bat.x) + param1*(ball.x-(-0.7f+bat.x)),(0.5f + bat.y) + param1*(ball.y-(0.5f + bat.y)),-0.5+param1*(ball.z+0.5));					// Top Left Of Player
                    glVertex3d((-0.7f+bat.x) + param2*(ball.x-(-0.7f+bat.x)),(0.5f + bat.y) + param2*(ball.y-(0.5f + bat.y)),-0.5+param2*(ball.z+0.5));

		            glVertex3d((0.7f + bat.x) + param1*(ball.x-(0.7f + bat.x)),(0.5f + bat.y) + param1*(ball.y-(0.5f + bat.y)),-0.5+param1*(ball.z+0.5));					// Top Right Of Player
		            glVertex3d((0.7f + bat.x) + param2*(ball.x-(0.7f + bat.x)),(0.5f + bat.y) + param2*(ball.y-(0.5f + bat.y)),-0.5+param2*(ball.z+0.5));

		            glVertex3d((-0.7f+bat.x) + param1*(ball.x-(-0.7f+bat.x)),(-0.5f + bat.y) + param1*(ball.y-(-0.5f + bat.y)),-0.5+param1*(ball.z+0.5));					// Top Left Of Player
		            glVertex3d((-0.7f+bat.x) + param2*(ball.x-(-0.7f+bat.x)),(-0.5f + bat.y) + param2*(ball.y-(-0.5f + bat.y)),-0.5+param2*(ball.z+0.5));					// Bottom Right Of Player

		            glVertex3d((0.7f + bat.x) + param1*(ball.x-(0.7f + bat.x)),(-0.5f + bat.y) + param1*(ball.y-(-0.5f + bat.y)),-0.5+param1*(ball.z+0.5));					// Top Right Of Player
		            glVertex3d((0.7f + bat.x) + param2*(ball.x-(0.7f + bat.x)),(-0.5f + bat.y) + param2*(ball.y-(-0.5f + bat.y)),-0.5+param2*(ball.z+0.5));

	            glEnd();
            }    
            
            param1+=0.05f;
            param2+=0.05f;
            Count++;
        }
/*
	    glBegin(GL_LINES);						// Start Drawing Our Player Using Lines
		    glVertex3d(-0.7f + bat.x,0.5f + bat.y,-0.5);					// Top Left Of Player
		    glVertex3d( ball.x, ball.y,ball.z);					// Bottom Right Of Player
		    glVertex3d(0.7f + bat.x,0.5f + bat.y ,-0.5);					// Top Right Of Player
		    glVertex3d( ball.x, ball.y,ball.z);
		    glVertex3d(-0.7f + bat.x,-0.5f + bat.y,-0.5);					// Top Left Of Player
		    glVertex3d( ball.x, ball.y,ball.z);					// Bottom Right Of Player
		    glVertex3d(0.7f + bat.x,-0.5f + bat.y ,-0.5);					// Top Right Of Player
		    glVertex3d( ball.x, ball.y,ball.z);
	    glEnd();
*/






    }

/*    if (ball.z>-4.0&&ball.dz>0)
    {
//        PlaySound("Data/SOUND136.wav", NULL, SND_ASYNC);

        glDisable(GL_BLEND);
	    glBindTexture(GL_TEXTURE_2D, texture[4]);
       
	    glColor3f(0.5f,0.0f,0.0f);					// Set Player Color To Light Green
        glLineWidth(3.0f);

	    glBegin(GL_LINES);						// Start Drawing Our Player Using Lines
		    glVertex3d(-0.7f + bat.x,0.5f + bat.y,-0.5);					// Top Left Of Player
		    glVertex3d( ball.x, ball.y,ball.z);					// Bottom Right Of Player
		    glVertex3d(0.7f + bat.x,0.5f + bat.y ,-0.5);					// Top Right Of Player
		    glVertex3d( ball.x, ball.y,ball.z);
		    glVertex3d(-0.7f + bat.x,-0.5f + bat.y,-0.5);					// Top Left Of Player
		    glVertex3d( ball.x, ball.y,ball.z);					// Bottom Right Of Player
		    glVertex3d(0.7f + bat.x,-0.5f + bat.y ,-0.5);					// Top Right Of Player
		    glVertex3d( ball.x, ball.y,ball.z);
	    glEnd();
    }
*/
    glEnable(GL_TEXTURE_2D);
    if (ball.z>-4.0)
    {
    	glBindTexture(GL_TEXTURE_2D, texture[20]);
    }
    else
    {
        glBindTexture(GL_TEXTURE_2D, texture[11]);
    }

    glColor4f(1.0f,1.0f,1.0f,0.25f);
    glEnable(GL_BLEND);
	glBegin(GL_QUADS);

    if(!Menu && !Instructions)
    {
		//Bottom left
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.025f + bat.x, -0.025f + bat.y, 0.0f + bat.z);//Bottom right
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -0.65f + bat.x, -0.025f + bat.y, 0.0f + bat.z);//Bottom left
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -0.65f + bat.x, -0.45f + bat.y, 0.0f + bat.z);//Top left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.025f + bat.x, -0.45f + bat.y, 0.0f + bat.z);//Top right

		//Bottom right
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(0.65f + bat.x, -0.025f + bat.y, 0.0f + bat.z);//Bottom right
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.025f + bat.x, -0.025f + bat.y, 0.0f + bat.z);//Bottom left
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.025f + bat.x, -0.45f + bat.y, 0.0f + bat.z);//Top left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(0.65f + bat.x, -0.45f + bat.y, 0.0f + bat.z);//Top right

		//Top left
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.025f + bat.x, 0.025f + bat.y, 0.0f + bat.z);//Bottom right
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -0.65f + bat.x, 0.025f + bat.y, 0.0f + bat.z);//Bottom left
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -0.65f + bat.x, 0.45f + bat.y, 0.0f + bat.z);//Top left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.025f + bat.x, 0.45f + bat.y, 0.0f + bat.z);//Top right

		//Top left
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(0.65f + bat.x, 0.025f + bat.y, 0.0f + bat.z);//Bottom right
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.025f + bat.x, 0.025f + bat.y, 0.0f + bat.z);//Bottom left
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.025f + bat.x, 0.45f + bat.y, 0.0f + bat.z);//Top left
		glTexCoord2f(1.0f, 1.0f); glVertex3f(0.65f + bat.x, 0.45f + bat.y, 0.0f + bat.z);//Top right
    
    }

	glEnd();
    glBindTexture(GL_TEXTURE_2D, texture[0]);				
//	glColor3f(1.0f,1.0f,1.0f);								


	glPrint(260,450,0,"Index:%2i",index);	    //Debugging 					
//	glPrint(260,435,0,"Count  :%2i",Count);        //Debugging
//	glPrint(260,420,0,"Active :%2i",test3);      //debugging
//	glPrint(260,405,0,"Brick  :%2i",Brick);        //debugging
//	glPrint(260,390,0,"Killed :%2i",test5);        //debugging



//	glColor3f(1.0f,1.0f,0.0f);								

    if(TimerCount<100)
    {
        glPrint(140,350,0,"Calculating Machine Performance :%2i",TimerCount);
    }

    if(TimerCount<200 && TimerCount>100)
    {
        glPrint(140,350,0,"            GO! GO! GO!");
    }

	glPrint(40,450,0, "SCORE :%2i",Score);
    glPrint(40,435,0, "LEVEL :%2i",level);
	glPrint(40,420,0, "LIVES :%2i",lives);

    if (NoOfBricksHit>1)
    {
        glPrint(40,115,0,"BRICKS HIT :%2i",NoOfBricksHit);
    }

    if (MultiBall>0)
    {
        glPrint(40,100,0,"SUPERBALL  :%2i",MultiBall);   
    }
    if (FastBall>0)
    {
        glPrint(40,85,0, "FASTBALL   :%2i",FastBall);
    }
    if (SlowBall>0)
    {
        glPrint(40,70,0, "SLOWBALL   :%2i",SlowBall);
    }
    if (Gun>0)
    {
        glPrint(40,55,0, "GUN        :%2i",Gun);
    }
    if (AddBrick>0)
    {
        glPrint(40,40,0, "ADDBRICK   :%2i",AddBrick);
    }
    if (MinusBrick>0)
    {
        glPrint(40,25,0, "MINUSBRICK :%2i",MinusBrick);
    }

    if (GameOver)											// Is The Game Over?
	{
		glColor3ub(rand()%255,rand()%255,rand()%255);		// Pick A Random Color
		glPrint(230,330,0,"    GAME OVER");						// Write GAME OVER To The Screen
		glPrint(230,314,0,"F4 begins new game");					// Write PRESS SPACE To The Screen
	}

    if (DisplayFPS)
    {

        Frame++;

        if (Frame==1)
        {
            Time3=TimerGetTime()/1000;
        }
        
        if (Frame==20)
        {
            Time4=TimerGetTime()/1000;
            FPS=20/(Time4-Time3);

            Frame=0;
        }

        glPrint(40,405,0,"FPS   :%2i",FloatToInt(FPS));
           
    }       

    if (DisplaySpeed)
    {
        glPrint(500,450,0,"dx :%2i",FloatToInt(ball.dx*1000));
        glPrint(500,435,0,"dy :%2i",FloatToInt(ball.dy*1000));
        glPrint(500,420,0,"dz :%2i",FloatToInt(ball.dz*1000));
        glPrint(500,405,0,"ds :%2i",FloatToInt(float(hypot(hypot(ball.dz*1000,ball.dy*1000),ball.dx*1000))));

    }        
    
    }



    if (Menu)
    {
        //Draw Box
        glDisable(GL_BLEND);
        glBindTexture(GL_TEXTURE_2D, texture[5]);
	    glBegin(GL_QUADS);
       		glNormal3f( 0.0f, 0.0f,-1.0f);
    		glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.6f, -1.9f, 0.0f);//Bottom right
	    	glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.1f, -1.9f, 0.0f);//Bottom left
		    glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.1f, -0.1f, 0.0f);//Top left
		    glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.6f, -0.1f, 0.0f);//Top right                  
        glEnd();
        //Draw Text
        glEnable(GL_BLEND);
        glBindTexture(GL_TEXTURE_2D, texture[0]);
        glPrint(440,200,0,"Paused");

            glPrint(350,170,0,"Bat Power            %2i",adjust);
        
        if (Particles)
        {
            glPrint(350,150,0,"Particles            ON");
        }
        else
        {
            glPrint(350,150,0,"Particles            OFF");            
        }

        if (DisplayFPS)
        {
            glPrint(350,130,0,"FPS                  ON");
        }
        else
        {
            glPrint(350,130,0,"FPS                  OFF");            
        }

            glPrint(350,110,0,"Particle density     %2i",Pdensity);
     
            glPrint(350,90,0, "Particle velocity    %2i",FloatToInt(Pvelocity)*100);            

        //Draw Highlight
        glBindTexture(GL_TEXTURE_2D, texture[9]);        
	    glBegin(GL_QUADS);
       		glNormal3f( 0.0f, 0.0f,-1.0f);
    		glTexCoord2f(1.0f, 0.0f); glVertex3f( 2.5f, -0.62f+(Option-1)*-.17f, 0.0f);//Bottom right
	    	glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.2f, -0.62f+(Option-1)*-.17f, 0.0f);//Bottom left
		    glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.2f, -0.45f+(Option-1)*-.17f, 0.0f);//Top left
		    glTexCoord2f(1.0f, 1.0f); glVertex3f( 2.5f, -0.45f+(Option-1)*-.17f, 0.0f);//Top right                  
        glEnd();        

    }

    if (Instructions)
    {
        glDisable(GL_BLEND);
        glBindTexture(GL_TEXTURE_2D, texture[5]);
	    glBegin(GL_QUADS);
       		glNormal3f( 0.0f, 0.0f,-1.0f);
    		glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.1f, -1.9f, 0.0f);//Bottom right
	    	glTexCoord2f(0.0f, 0.0f); glVertex3f( -2.6f, -1.9f, 0.0f);//Bottom left
		    glTexCoord2f(0.0f, 1.0f); glVertex3f( -2.6f, -0.1f, 0.0f);//Top left
		    glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.1f, -0.1f, 0.0f);//Top right                  
        glEnd();
        //Draw Text
        glEnable(GL_BLEND);
        glBindTexture(GL_TEXTURE_2D, texture[0]);
        glPrint(150,200,0,"Paused");
//                        ##############################
        glPrint(20,170,0,"Reflect the ball with the bat.");
        glPrint(20,150,0,"Where  the ball  hits the  bat");
        glPrint(20,130,0,"dictates  how   the   ball  is");
        glPrint(20,110,0,"reflected. Orange  Bricks give");
        glPrint(20,90,0, "bonuses.  Hit  muliple  bricks");
        glPrint(20,70,0, "without  relfecting  with  bat");
        glPrint(20,50,0, "for   big  points.   Menu   is");
        glPrint(20,30,0, "Controlled  with  cursor  keys");

    }        


	return TRUE;											// Everything Went OK
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION : KILL GL WINDOW                                            //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GLvoid KillGLWindow(GLvoid)									// Properly Kill The Window
{
	if (fullscreen)											// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);						// If So Switch Back To The Desktop
		ShowCursor(TRUE);									// Show Mouse Pointer
	}

	if (hRC)												// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))						// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))							// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;											// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))						// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;											// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))						// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;											// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))				// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;										// Set hInstance To NULL
	}

	KillFont();												// Kill The Font We Built
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                    FUNCTION : CREATE GL WINDOW                                             //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;									// Holds The Results After Searching For A Match
	WNDCLASS	wc;												// Windows Class Structure
	DWORD		dwExStyle;										// Window Extended Style
	DWORD		dwStyle;										// Window Style
	RECT		WindowRect;										// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;									// Set Left Value To 0
	WindowRect.right=(long)width;								// Set Right Value To Requested Width
	WindowRect.top=(long)0;										// Set Top Value To 0
	WindowRect.bottom=(long)height;								// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;									// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;								// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}
	
    ShowCursor(FALSE);

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);	// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,						// Extended Style For The Window
								"OpenGL",						// Class Name
								title,							// Window Title
								dwStyle |						// Defined Window Style
								WS_CLIPSIBLINGS |				// Required Window Style
								WS_CLIPCHILDREN,				// Required Window Style
								0, 0,							// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,							// No Parent Window
								NULL,							// No Menu
								hInstance,						// Instance
								NULL)))							// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=							// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),							// Size Of This Pixel Format Descriptor
		1,														// Version Number
		PFD_DRAW_TO_WINDOW |									// Format Must Support Window
		PFD_SUPPORT_OPENGL |									// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,										// Must Support Double Buffering
		PFD_TYPE_RGBA,											// Request An RGBA Format
		bits,													// Select Our Color Depth
		0, 0, 0, 0, 0, 0,										// Color Bits Ignored
		0,														// No Alpha Buffer
		0,														// Shift Bit Ignored
		0,														// No Accumulation Buffer
		0, 0, 0, 0,												// Accumulation Bits Ignored
		16,														// 16Bit Z-Buffer (Depth Buffer)  
		0,														// No Stencil Buffer
		0,														// No Auxiliary Buffer
		PFD_MAIN_PLANE,											// Main Drawing Layer
		0,														// Reserved
		0, 0, 0													// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))										// Did We Get A Device Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))				// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))					// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))							// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}	

	if(!wglMakeCurrent(hDC,hRC))								// Try To Activate The Rendering Context
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);									// Show The Window
	SetForegroundWindow(hWnd);									// Slightly Higher Priority
	SetFocus(hWnd);												// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);								// Set Up Our Perspective GL Screen

	if (!InitGL())												// Initialize Our Newly Created GL Window
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	return TRUE;												// Success
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                       FUNCTION : WINPROC                                                   //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK WndProc(	HWND	hWnd,						// Handle For This Window
							UINT	uMsg,						// Message For This Window
							WPARAM	wParam,						// Additional Message Information
							LPARAM	lParam)						// Additional Message Information
{
	switch (uMsg)												// Check For Windows Messages
	{
		case WM_ACTIVATE:										// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))								// Check Minimization State
			{
				active=TRUE;									// Program Is Active
			}
			else												// Otherwise
			{
				active=FALSE;									// Program Is No Longer Active
			}

			return 0;											// Return To The Message Loop
		}

		case WM_SYSCOMMAND:										// Intercept System Commands
		{
			switch (wParam)										// Check System Calls
			{
				case SC_SCREENSAVE:								// Screensaver Trying To Start?
				case SC_MONITORPOWER:							// Monitor Trying To Enter Powersave?
				return 0;										// Prevent From Happening
			}
			break;												// Exit
		}

		case WM_CLOSE:											// Did We Receive A Close Message?
		{
			PostQuitMessage(0);									// Send A Quit Message
			return 0;											// Jump Back
		}

		case WM_KEYDOWN:										// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;								// If So, Mark It As TRUE
			return 0;											// Jump Back
		}

		case WM_KEYUP:											// Has A Key Been Released?
		{
			keys[wParam] = FALSE;								// If So, Mark It As FALSE
			return 0;											// Jump Back
		}

		case WM_SIZE:											// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));		// LoWord=Width, HiWord=Height
			return 0;											// Jump Back
		}
	}

	return DefWindowProc(hWnd,uMsg,wParam,lParam);				// Pass All Unhandled Messages To DefWindowProc
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                        FUNCTION : WINMAIN                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE	hInstance,						// Instance
					HINSTANCE	hPrevInstance,					// Previous Instance
					LPSTR		lpCmdLine,						// Command Line Parameters
					int			nCmdShow)						// Window Show State
{
	MSG		msg;												// Windows Message Structure
	BOOL	done=FALSE;											// Bool Variable To Exit Loop

	// Ask The User Which Screen Mode They Prefer
	if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;										// Windowed Mode
	}

	// Create Our OpenGL Window
	if (!CreateGLWindow("3D Breakout",640,480,16,fullscreen))
	{
		return 0;												// Quit If Window Was Not Created
	}

	PopulateBrickArray();
    ModifyBrickArray();
    ResetObjects();												// Set Player / Enemy Starting Positions
	InitialiseParticles();
    TimerInit();

	while(!done)												// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))				// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)							// Have We Received A Quit Message?
			{
				done=TRUE;										// If So done=TRUE
			}
			else												// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);							// Translate The Message
				DispatchMessage(&msg);							// Dispatch The Message
			}
		}
		else													// If There Are No Messages
		{
			float start=TimerGetTime();							// Grab Timer Value Before We Draw
			
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
			{
				done=true;										// ESC or DrawGLScene Signalled A Quit
			}
			else												// Not Time To Quit, Update Screen
			{
				SwapBuffers(hDC);								// Swap Buffers (Double Buffering)
			}

//			while(TimerGetTime()<start+float(steps[adjust]*2.0f)) {}	// Waste Cycles On Fast Systems

            if (!GameOn&&!FirstPass)
            {            
                PlaySound("data/funkydrummer.wav", NULL, SND_ASYNC);
                FirstPass=true;
            }

            if (keys[' '])
            {
                GameOn=true;
                keys[' ']=false;
            }
                      
            if (!GameOn)
            {
                Zoom+=0.15f;
        
                if(Zoom>0.0)
                {
                    Zoom=0.0;
                }

            }

            if ((Count2==1)&&(Zoom==0.0))
            {
                PlaySound("data/die.wav", NULL, SND_SYNC);
                Count2++;
            }             
            

			if (keys[VK_F1])									// Is F1 Being Pressed?
			{
				keys[VK_F1]=false;								// If So Make Key FALSE
				KillGLWindow();									// Kill Our Current Window
				fullscreen=!fullscreen;							// Toggle Fullscreen / Windowed Mode
				// Recreate Our OpenGL Window
				if (!CreateGLWindow("3D Breakout",640,480,16,fullscreen))
				{
					return 0;									// Quit If Window Was Not Created
				}
			}

			if (keys[VK_F2])									// Is F1 Being Pressed?
			{
				keys[VK_F2]=false;								// If So Make Key FALSE
                Menu=!Menu;                                     // Toggle on and off
            }

			if (keys[VK_F3])									// Is F1 Being Pressed?
			{
				keys[VK_F3]=false;								// If So Make Key FALSE
                Instructions=!Instructions;                                     // Toggle on and off
            }

			if (keys[VK_F5])									// Is F1 Being Pressed?
			{
				keys[VK_F5]=false;								// If So Make Key FALSE
                CheatEngaged=true;                                     // Toggle on and off
            }

			if (keys[VK_F6])									// Is F1 Being Pressed?
			{
				keys[VK_F6]=false;								// If So Make Key FALSE
                lives++;                                     // Toggle on and off
            }

			if (keys[VK_F7])									// Is F1 Being Pressed?
			{
				keys[VK_F6]=false;								// If So Make Key FALSE
                ball.dz=0.0f;                                     // Toggle on and off
                ball.x=0.0f;
                ball.y=0.0f;
                ball.z=-5.0f;
            }    

            if (Menu)
            {    

                keys[' ']=false;

                if (keys[VK_DOWN])
				{
                    keys[VK_DOWN]=false;
                    Option++;
                    if (Option>6)
                    {
                        Option=6;
                    }   
				}

				if (keys[VK_UP])
				{
                    keys[VK_UP]=false;
				    Option--;
                    if (Option<1)
                    {
                        Option=1;
                    }	
				}

				if (keys[VK_RIGHT])
				{
	                keys[VK_RIGHT]=false;
                    if (Option==1)
                    {
                        adjust++;
                        if (adjust>5)
                        {
                            adjust=5;
                        }
                    }
                    if (Option==2) {Particles=true;}
                    if (Option==3) {DisplayFPS=true;}
                    if (Option==4)
                    {
                        Pdensity+=10;
                        if (Pdensity>500)
                        {
                            Pdensity=500;
                        }
                    }
                    if (Option==5)
                    {
                        Pvelocity+=1.0;
                        if (Pvelocity>100.0f)
                        {
                            Pvelocity=100.0f;
                        }
                    }                 
				}

				if (keys[VK_LEFT])
				{
				    keys[VK_LEFT]=false;
                    if (Option==1)
                    {
                        adjust--;
                        if (adjust<1)
                        {
                            adjust=1;
                        }
                    }
                    if (Option==2) {Particles=false;}
                    if (Option==3) {DisplayFPS=false;}
                    if (Option==4)
                    {
                        Pdensity-=10;
                        if (Pdensity<100)
                        {
                            Pdensity=100;
                        }
                    }
                    if (Option==5)
                    {
                        Pvelocity-=1.0;
                        if (Pvelocity<-100.0f)
                        {
                            Pvelocity=-100.0f;
                        }
                    }                
			    }

			}
        	
            

		    //MAIN GAME LOOP
			if (!GameOver && active && !Menu && GameOn && !Instructions)							// If Game Isn't Over And Programs Active Move Objects
			{
				
                DisplaceObjects();

                //Move Bricks
                for(loop1=1;loop1<40;loop1++)
                {
                    if(Wall[loop1].Moving)
                    {
                        MoveBricks(loop1);
                    }
                }  
                
                LimitBallMovement();
                DecelerateBat();

                GetCursorPos(&mpos);
                
                bat.x=(float) mpos.x/640*5.4f-2.7f;
                bat.y=(float) (480-mpos.y)/480*4.0f-2.0f;
              
                LimitBatMovement();
                CheckForContainerCollision();
                CheckForBatCollision();
                CheckForBrickCollision();

                EvolveWeapons();
                
                test3=0;

                //PARTICLE PROCESSING
                CreateNewParticle();                                    //Note CreateNewParticle() not called from with in loop
                                                                        //Due to different particles in the array needing to be created in different ways

                for (loop1=0;loop1<MAX_PARTICLES;loop1++) 
                {
                    DisplaceParticle(loop1);
                    ReflectParticle(loop1);
                    //ReflectParticle2(loop1);
                    AgeParticle(loop1);
                    DecelerateParticle(loop1);

                    if (IsParticleLive(loop1))
                    {test3++;}
                }                    

                //BALL GONE OFF SCREEN?
                if (ball.z+BallThickness>0.0)
                {
                    PlaySound("data/hourglass.wav", NULL, SND_SYNC);   
                    lives--;
                    ResetObjects();
                    InitialiseParticles();
                }
                
                //HAS WALL BEEN CLEARED?
                WallCleared=TRUE;

                
                for (loop1=1;loop1<=40;loop1++)
                {
                    if (!Wall[loop1].BrickCleared)
                    {
                        
                        WallCleared=false;
                    }
                    
                }
			    
                //IS THE PLAYER OUT OF LIVES
                if (lives==0)
                {
                    GameOver=TRUE;
                }
                
                //DEAL WITH WALL BEING CLEARED
                if (WallCleared||CheatEngaged)
                {
                    for (loop1=1;loop1<3;loop1++)
                    {
                        PlaySound("data/funkydrummer.wav", NULL, SND_SYNC);
                    }
                    Score+=1000;
                    level++;
                    lives++;                    
                    ResetObjects();

                    index=rand()%8+1;
                    if(index>2)
                    {
                        index+=11;
                        if(index==12)
                        {
                            index=13;
                        }
                    }

                    PopulateBrickArray();                   
                    ModifyBrickArray();
                    ball.dz*=0.90f;
                    if(ABS(ball.dz)<1.5)
                    {
                        ball.dz*=1.5;
                    }
                    //Reset any power ups
                    SlowBall=0;                                             
                    FastBall=0;
                    MultiBall=0;
                    Gun=0;
                    AddBrick=0;
                    MinusBrick=0;
                    NoOfBricksHit=0;
                    
                    //backgrounds Index     Brick Textures
                    //  1           1       Metal6,stone6,stone1    
                    //  2           2       Stone4,stone5
                    //  3           13
                    //  4           14      Metal3,4,8
                    //  5           15      Matt2,Matt
                    //  6           16      Wierd
                    //  7           17      Metal2
                    //  8           18      Stone1,tile
                    //  9           19      Hole

                    CheatEngaged=false;



                }
            }
            //GAMEOVER SCENARIO
            else												// Otherwise
			{
				if (keys[VK_F4])									// If Spacebar Is Being Pressed
				{
                    keys[VK_F4]=false;
					GameOver=false;								// gameover Becomes FALSE
					WallCleared=true;							// filled Becomes TRUE
                    GameOn=true;
                    Menu=false;
                    Instructions=false;
					level=1;									// Starting Level Is Set Back To One
					lives=5;
                    PopulateBrickArray();									// Lives Is Set To Five
                    ModifyBrickArray();
                    ResetObjects();
                    Score=0;
                    InitialiseParticles();
				}
			}

						
		}
	}

	// Shutdown
	KillGLWindow();												// Kill The Window
	return (msg.wParam);										// Exit The Program
}
